/* -*- Mode: C ; Coding: euc-japan -*- */
/* Time-stamp: <2010-02-01 23:27:46 cyamauch> */

/*
  EGGX / ProCALL  version 0.90
                   eggx_base.c
  ˤδñܻؤƺC FORTRAN ξѤ
  X11եå饤֥ꡥ
 */

#define _EGGX_BASE_C

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/Xlocale.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>
#include <dirent.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <locale.h>

#include "_eggx_internal_defs.h"
#include "eggx_base.h"
#include "exec_xslave.h"

#ifdef __CYGWIN__
#ifndef CYGWIN
#error "You should use Makefile.cygwin"
#endif
#endif

#define PC_UNITLEN 4
#define RTOC_UNITLEN 32

#define SLAVEFILE "_xslave_"

#define DEFAULTFONTSET "-*-fixed-medium-r-normal--14-*"
#define FALLBACKFONTSET "fixed,-*--14-*"

#ifdef NO_ISINF
#define ISINF(x) isnan(x)
#else
#define ISINF(x) isinf(x)
#endif

/* ɥѤι¤ */
struct pctg {
    Window win ;		/* Window  ID */
    Window iconwin ;		/* Icon Window ID */
    Pixmap pix[2] ;		/* Pixmap  ID */
    GC pxgc ;			/* 쥤Υԡ */
    GC gc ;
    XFontStruct *fontstruct ;	/* ե */
    XFontSet fontset ;		/* եȥå */
    unsigned short fontheight ;
    pid_t cpid ;		/* ҥץpid */
    int flg ;
    int plx ;			/* plotǻѤxɸ */
    int ply ;			/* plotǻѤyɸ */
    float winxs ;		/* ɥ(ɸ) */
    float winxe ;
    float winys ;
    float winye ;
    int wszx ;			/* եåΥ */
    int wszy ;
    float wicx ;		/* xyconvǻ */
    float wicy ;
    int sly ;			/* ɽ쥤 */
    int wly ;			/* 񤭹쥤 */
    int fsz ;			/* եȥ */
    unsigned long bgcolor ;	/* طʿ */
    GC bggc ;
    long attributes ;		/* EGGX Ǥ°ե饰 */
} ;

/* եȥåȤΥå */
struct fontsettg {
    char *fontname;		/* ե̾ */
    XFontSet fontset;		/* եȥåȹ¤ */
    char **missing_list;
} ;

/* 
 * ץ饤١Ȥ
 */

/* ASCII եȤ */
static const char *Pc_fnt[24] = { "5x7","5x7","5x7","5x7","5x7","5x7","5x7",
				  "5x8","6x9","6x10","6x10","6x12","6x13",
				  "7x14","7x14","8x16","8x16","8x16","8x16",
				  "10x20","10x20","10x20","10x20","12x24" };
static const char *Pc_fallbackfnt_fmt = "-*-fixed-medium-r-normal--%s-*";
static const char *Pc_fallbackfnt = "fixed";

/*
 * ץ饤١Ȥѿ
 */

/* ɥطδ */
static struct pctg *volatile Pc = NULL ;
static volatile int N_Pc = 0 ;			/* Pc ΥХåեθĿ */
static integer Wn = -1 ;			/* ProCALLߴ롼Ѥwindowֹ */

static Display* Pc_dis = NULL ;			/* Display ID */
static Colormap Pc_cmap ;
static int Pc_depth = 8 ;			/* XФξ󤤤 */
static XVisualInfo *Pc_vinfo_ptr = NULL ;
static Visual *Pc_visual ;
static int Red_depth,Green_depth,Blue_depth ;
static int Red_sft,Green_sft,Blue_sft ;

static XColor *Pc_cmapcolors = NULL ;		/* cmapơ֥: 8bpp  */
static int Pc_ncmapcolors = 0 ;			/* θĿ */
static struct fontsettg *Pc_fscache = NULL ;	/* եȥåȥå */
static int Pc_nfscache = 0 ;			/* θĿ */

static int Pc_nonblock = DISABLE ;		/* Υ֥å󥰤Υե饰 */
static int Pc_nonflush = DISABLE ;		/* ưեåΥե饰 */

/* ʲɥץݻ */
static int Pc_bdr_width = 0 ;			/* ܡ */
static long Pc_attributes = 0 | AUTOREDRAW ;	/* ɥ° */

static char *Pc_storename = NULL ;
static char *Pc_iconname = NULL ;
static char *Pc_classhint_res_name = NULL ;
static char *Pc_classhint_res_class = NULL ;
static char *Pc_geometry = NULL ;
static char *Pc_bgcolor = NULL ;
static char *Pc_bordercolor = NULL ;

static char _Pname[] = "EGGX" ;
static char *Pname = _Pname ;			/* ɥ̾ */

/* ʲץޤ */
static pid_t Pid ;				/* ץid */
static volatile int Bsyflg = 0 ;		/* ҥץ!flag */
static volatile pid_t Cpid_imgsave ;		/* imgsaveƤcpid */
static volatile pid_t Cpid_tmp ;		/* ƥݥcpid */
/* ҥץΥե̾ */
static char Exec_slave_tmp[] = "/tmp/" SLAVEFILE "XXXXXX" ;
static int Exec_fd = -1 ;

/* 2ĤϥɤˤäƤ뤬¼ȤäƤʤ */
static volatile int Ihflg = 0 ;			/* ߶ػߥե饰 */
static volatile int Exitflg = 0 ;		/* ߤˤäƽλΤ餵줿ˤϤǤʤˤƤ */


/*  */
/*             Ūؿ             */
/*  */

/* 顼åդmalloc,realloc,strdup */
static void *_eggx_xmalloc( size_t size )
{
    void *rt ;
    rt=malloc(size) ;
    if( rt==NULL ){
        fprintf(stderr,"EGGX: [ERROR] malloc() failed.\n") ;
        exit(1) ;
    }
    return( rt ) ;
}

static void *_eggx_xrealloc( void *ptr, size_t size )
{
    void *rt ;
    rt=realloc(ptr,size) ;
    if( rt==NULL ){
        fprintf(stderr,"EGGX: [ERROR] realloc() failed.\n") ;
        exit(1) ;
    }
    return( rt ) ;
}

static char *_eggx_xstrdup( const char *s )
{
    char *rt = strdup(s) ;
    if ( rt == NULL ) {
        fprintf(stderr,"EGGX: [ERROR] strdup() failed.\n") ;
        exit(1) ;
    }
    return (rt) ;
}

/* va_copy Ȥäǡvsnprintf ̵OSǤϥѥԲĤȻפ */
#ifdef NO_VSNPRINTF
static int _eggx_dev_null_w_open( void )
{
    int f ;
    f=open("/dev/null",O_WRONLY) ;
    if( f == -1 ){
	fprintf(stderr,"EGGX: [ERROR] Cannot open /dev/null.\n") ;
	exit(1) ;
    }
    return( f ) ;
}

static char *_eggx_vasprintf( const char *format, va_list ap )
{
    char *rt = NULL;
    int f, nn;
    FILE *fp;
    va_list aq;

    if ( format == NULL ) goto quit;

    f = _eggx_dev_null_w_open();
    fp = fdopen(f,"w");
    if ( fp == NULL ) {
	fprintf(stderr,"EGGX: [ERROR] Cannot open /dev/null.\n");
	exit(1);
    }
    va_copy(aq, ap);
    nn = vfprintf(fp,format,ap);
    va_end(ap);
    fclose(fp);
    close(f);

    rt = (char *)_eggx_xmalloc(sizeof(char)*(nn+1));
    vsprintf(rt,format,aq);
    va_end(aq);

 quit:
    return rt;
}
#else
static char *_eggx_vasprintf( const char *format, va_list ap )
{
    const int ini_len = 64;
    char *rt = NULL;
    int nn;
    va_list aq;

    if ( format == NULL ) goto quit;

    va_copy(aq, ap);
    rt = (char *)_eggx_xmalloc(sizeof(char)*ini_len);
    nn = vsnprintf(rt,ini_len,format,ap);
    va_end(ap);

    if ( ini_len <= nn ) {
	rt = (char *)_eggx_xrealloc(rt,sizeof(char)*(nn+1));
	vsnprintf(rt,nn+1,format,aq);
    }
    va_end(aq);

 quit:
    return rt;
}
#endif

static char *_eggx_asprintf( const char *format, ... )
{
    char *rt = NULL;
    va_list ap;

    if ( format == NULL ) goto quit;

    va_start(ap, format);
    rt = _eggx_vasprintf(format,ap);
    va_end(ap);

 quit:
    return rt;
}

/* ߤꤹ */
static int _eggx_signal( int signum, int sa__flags,
			 void (*sa__handler)(int) )
{
    struct sigaction sa ;
    sigset_t sm ;
    /* ʥޥ */
    sigemptyset( &sm ) ;
    sigaddset( &sm, signum ) ;
    /* Ͽ */
    sa.sa_handler = sa__handler ;
    sa.sa_mask = sm ;
    sa.sa_flags = sa__flags ;
    return( sigaction( signum, &sa, NULL ) ) ;
}

static char *_eggx_xstrdup_toupper( const char *s )
{
    int i ;
    char *rt ;
    rt = _eggx_xstrdup( s ) ;
    if ( rt!=NULL ){
	for( i=0 ; i<strlen(s) ; i++ ){
	    int ch = ((const unsigned char *)s)[i];
	    ((unsigned char *)rt)[i] = toupper(ch);
	}
    }
    return(rt) ;
}

/* ץΥޥ̾Ĵ٤֤֤ͤϥҡסƤӽФ¦free() */
static char *_eggx_getpname( pid_t pd )
{
    char arg_ps0[] = "/bin/ps";
    char arg_ps1[] = "/usr/bin/ps";
    char arg_opt_p[] = "-p";
    char arg_opt_f[] = "-f";
    char *ret;
    char *ptr,*eptr ;
    int pfds[2] ;
    int status ;
    pid_t pid ;
    char *args[]= { arg_ps0, arg_opt_p, NULL, arg_opt_f, NULL } ;
    char *args0[]= { arg_ps1, arg_opt_p, NULL, arg_opt_f, NULL } ;
    char *buf=NULL ;
    char *name=NULL ;
    int i ;
    FILE *fp ;
    int mlc ;
    int c,cnt=0,line_cnt=0 ;
    int cmd_idx=-1;	/* default */

#ifdef ANOTHERPS
    goto err ;
#endif

    name = _eggx_asprintf("%ld",(long)pd);

    args[2]=name ;
    args0[2]=name ;
    
    while( 1 ){
	if( pipe(pfds)<0 ) goto err ;
	if( ( pid=fork() ) < 0 ) goto err ;
	if( pid == 0 ){
	    dup2( pfds[1],1 ) ;	/* ɤ߹ */
	    close( pfds[1] ) ;
	    close( pfds[0] ) ;
	    execv( *args, args ) ;
	    execv( *args0, args0 ) ;
	    fprintf(stderr,"EGGX: [ERROR] Cannot exec 'ps' command.\n") ;
	    if( Pid == getppid() ){
		kill(Pid,SIGTERM) ;
	    }
	    _exit(-1) ;
	}
	close( pfds[1] ) ;
	fp = fdopen( pfds[0],"r") ;
	if( fp!=NULL ){
	    cnt=0 ;
	    line_cnt=0 ;
	    mlc = 64 ;
	    buf=(char *)_eggx_xmalloc(sizeof(char)*mlc) ;
	    while( (c=fgetc(fp))!=EOF ){
		if( cnt == mlc-1 ){
		    mlc += 64 ;
		    buf=(char *)_eggx_xrealloc(buf,sizeof(char)*mlc) ;
		}
		if( c == '\n' ) line_cnt++ ;
		if( c < 0x020 ) c=0x020 ;
		buf[cnt]=c ;
		cnt++ ;
	    }
	    buf[cnt]='\0' ;
	    fclose(fp) ;
	}
	close( pfds[0] ) ;
	while(wait(&status)!=pid) ; 	/* ϳߤǽƤʤ */
	if( line_cnt > 1 ) break ;		/* /procʲ˽񤭹ޤޤǤ */
	eggx_msleep( 10 ) ;			/* ֤뤳Ȥ */
    } ;
    if( cnt == 0 ) goto err ;
    for( i=0 ; i<cnt ; i++ ){
	if( 0x020 < buf[cnt-1-i] ) break ;
	buf[cnt-1-i]='\0' ;
    }
    if( strlen(buf) < 2 ) goto err ;
    ptr=buf ;
    if( *ptr != 0x020 ) i=1 ;
    else i=0 ;
    while( *++ptr != '\0' ){
	if( *(ptr-1) == 0x020 && *ptr != 0x20 ){
	    i++ ;
	    if ( strncmp(ptr,"CMD ",4) == 0 ) cmd_idx=i;
	    else if ( strncmp(ptr,"COMMAND ",8) == 0 ) cmd_idx=i;
	    if( 0 <= cmd_idx && i == cmd_idx * 2 ) break ;
	}
    }
    if( *ptr == '\0' ) goto err ;
    eptr=ptr ;
    while( *++eptr != '\0' ){
	if( *eptr == 0x020 ) break ;
    }
    *eptr='\0' ;
    ptr=eptr ;
    while( *--ptr != 0x020 ){
	if( *ptr == '/' ) break ;
    }
    ptr++ ;

    if( name != NULL ) free(name) ;
    ret = _eggx_xstrdup(ptr);
    free(buf) ;
    return( ret ) ;
 err:
    if( buf  != NULL ) free(buf) ;
    if( name != NULL ) free(name) ;
    return(NULL) ;
}

/*  */
/*           EGGX Ѥδؿ              */
/*  */

/* ============= ƥݥեϢ ============= */

#ifdef CYGWIN
static char **volatile Remove_list = NULL;
static volatile int Remove_cnt = 0;
static int add_to_removelist( const char *filename )
{
    int i;
    char **old_ptr;
    char **new_ptr;
    old_ptr = Remove_list;
    new_ptr = (char **)_eggx_xmalloc(sizeof(char *)*(Remove_cnt+1));
    for ( i=0 ; i < Remove_cnt ; i++ ) new_ptr[i] = old_ptr[i];
    Remove_list = new_ptr;
    Remove_list[Remove_cnt] = _eggx_xstrdup(filename);
    Remove_cnt++;
    if ( old_ptr != NULL ) free(old_ptr);
    return (0);
}

static void remove_removelist( void )
{
    int i;
    for ( i=0 ; i < Remove_cnt ; i++ ) {
	if ( Remove_list[i] != NULL ) {
	    struct stat st;
	    while ( remove( Remove_list[i] ) ) {
		if ( stat( Remove_list[i], &st ) ) break;
		eggx_msleep(10);
	    }
	    free(Remove_list[i]);
	    Remove_list[i] = NULL;
	}
    }
    if ( Remove_list != NULL ) {
	Remove_cnt = 0;
	free(Remove_list);
	Remove_list = NULL;
    }
    return;
}
#endif

static int mkexecfile( void )
{
    struct stat st ;
    mode_t mode ;

#ifdef CYGWIN
    if( 0 < Remove_cnt ){
	if( stat( Exec_slave_tmp, &st )==0 ){
	    return(0) ;
	}
    }
#endif

    /* if( Exec_fd != -1 ) return( 0 ) ; */
    while(1){
	strcpy(Exec_slave_tmp,"/tmp/" SLAVEFILE "XXXXXX") ;
#ifdef NO_MKSTEMP	/* mkstempʤ */
	if( mktemp( Exec_slave_tmp ) == NULL ) return( -1 ) ;
	Exec_fd = open( Exec_slave_tmp, O_RDWR|O_CREAT|O_EXCL, S_IRUSR|S_IWUSR) ;
#else
	Exec_fd = mkstemp( Exec_slave_tmp ) ;
#endif
	if( Exec_fd == -1 ) return( -1 ) ;

	/* ǰΤᡤstatǳǧ */
	if( stat( Exec_slave_tmp, &st ) ){
	    close( Exec_fd ) ;
	    Exec_fd=-1 ;
	    remove(Exec_slave_tmp) ;
	    eggx_msleep( 10 ) ;
	    continue ;
	}
	if( write( Exec_fd, _xslave_, sizeof(_xslave_) ) != sizeof(_xslave_) ){
	    close( Exec_fd ) ;
	    Exec_fd=-1 ;
	    remove(Exec_slave_tmp) ;
	    eggx_msleep( 10 ) ;
	    continue ;
	}
	if( stat( Exec_slave_tmp, &st ) ){
	    close( Exec_fd ) ;
	    Exec_fd=-1 ;
	    remove(Exec_slave_tmp) ;
	    eggx_msleep( 10 ) ;
	    continue ;
	}
	break ;
    }
    mode=st.st_mode ;
    chmod( Exec_slave_tmp, mode | S_IXUSR ) ;
    fsync(Exec_fd) ;
    /* close(Exec_fd) ; */	/* closeʤexecvľclose */
#ifdef CYGWIN
    add_to_removelist(Exec_slave_tmp) ;
#endif
    return( 0 ) ;
}

static void rmexecfile( void )
{
    if( Exec_fd != -1 ){
	close(Exec_fd) ;
	Exec_fd = -1 ;
    }
#ifndef CYGWIN
    remove( Exec_slave_tmp ) ;
#endif
}


/* ============= ߴϢ ============= */

/* ҥץλν */
static void chldexithandler( int dummy )
{
    pid_t pid ;
    int status ;
    pid = waitpid(-1, &status, WNOHANG) ;
    if( pid == Cpid_imgsave ){
	if( Bsyflg == 1 ) Bsyflg=0 ;	/* Bsyflg==-1λϤʤ */
	Cpid_imgsave=0 ;
    }    
    else{
	int i ;
	for( i=0 ; i < N_Pc ; i++ ){
	    if( Pc[i].flg!=0 ){
		if( pid == Pc[i].cpid ){
		    Pc[i].cpid = 0 ;
		}
	    }
	}
    }
    if( pid == Cpid_tmp ) Cpid_tmp=0 ;
}

static void c_err_handler( int dummy )
{
    Bsyflg=-1 ;
}

static void c_rdy_handler( int dummy )
{
    Bsyflg=1 ;
}

static void killallchld()
{
    int i;
    if ( 0 < Cpid_imgsave ) {
	kill(Cpid_imgsave,SIGTERM);
	while ( 0 < Cpid_imgsave ) {
	    eggx_msleep( 10 );
	}
    }
    for ( i=0 ; i < N_Pc ; i++ ) {
	if ( Pc[i].flg != 0 ) {
	    if ( 0 < Pc[i].cpid ) {
		kill(Pc[i].cpid,SIGTERM);
		while ( 0 < Pc[i].cpid ) {
		    eggx_msleep( 10 );
		}
	    }
	}
    }
}

/* OFF */
static void iusr_end( void )
{
    _eggx_signal( SIGUSR2, 0, SIG_DFL ) ;
    _eggx_signal( SIGUSR1, 0, SIG_DFL ) ;
    _eggx_signal( SIGTERM, 0, SIG_DFL ) ;
    _eggx_signal( SIGINT, 0, SIG_DFL ) ;
    _eggx_signal( SIGCHLD, 0, SIG_DFL ) ;
}

static void wait_child( void )
{
    while( Bsyflg ){
	eggx_msleep( 10 ) ;
	/* fprintf(stderr,"waiting cpid=%d\n",Cpid_imgsave) ; */
    }
}

static void iint_handler( int dummy )
{
    /*
    if( Ihflg ) Exitflg = 1 ;
    else exit(0) ;
    */
    /* wait_child() ; */	/* imgsaveԤ */
    /* iusr_end() ; */
    exit(130);
}

static void iterm_handler( int dummy )
{
    /*
    if( Ihflg ) Exitflg = 1 ;
    else exit(0) ;
    */
    /* wait_child() ; */	/* imgsaveԤ */
    /* iusr_end() ; */
    exit(143);
}

/* ߥå */
static void iusr_start( void )
{
    _eggx_signal( SIGCHLD, SA_NOCLDSTOP|SA_RESTART, &chldexithandler ) ;
    _eggx_signal( SIGINT, 0, &iint_handler ) ;
    _eggx_signal( SIGTERM, 0, &iterm_handler ) ;
    _eggx_signal( SIGUSR1, 0, &c_rdy_handler ) ;
    _eggx_signal( SIGUSR2, 0, &c_err_handler ) ;
}

static void chkexit( void )
{
    if( Exitflg ) iint_handler( 0 ) ;
}

/* ============= Ϣ ============= */

static void do_auto_flush( void )
{
    if ( Pc_nonflush != ENABLE && Pc_dis != NULL ) {
	XFlush( Pc_dis );
    }
    return;
}

/* cmapơ֥뤫 pixel 򥲥åȡξϿ롥8bpp λ˻Ȥ */
static void get_colorpixel_from_cmap( Colormap cmap, XColor *color_ptr )
{
    if ( Pc_cmapcolors != NULL ) {
	int i;
	for ( i=0 ; i < Pc_ncmapcolors ; i++ ) {
	    if ( Pc_cmapcolors[i].red == color_ptr->red &&
		 Pc_cmapcolors[i].green == color_ptr->green &&
		 Pc_cmapcolors[i].blue == color_ptr->blue ) {
		*color_ptr = Pc_cmapcolors[i];
		goto quit;
	    }
	}
    }
    if ( XAllocColor(Pc_dis, cmap, color_ptr) == 0 ) {
	color_ptr->pixel = 0;
	fprintf(stderr,"EGGX: [WARNING] XAllocColor() failed.\n");
	goto quit;
    }
    Pc_cmapcolors = (XColor *)_eggx_xrealloc(Pc_cmapcolors,
				  sizeof(*Pc_cmapcolors)*(Pc_ncmapcolors + 1));
    Pc_cmapcolors[Pc_ncmapcolors] = *color_ptr;
    Pc_ncmapcolors ++;

 quit:
    return;
}

/* cmapơ֥ */
static void free_cmap_table()
{
    if ( Pc_cmapcolors != NULL ) {
	free(Pc_cmapcolors);
	Pc_cmapcolors = NULL;
	Pc_ncmapcolors = 0;
    }
    return;
}

/* ̾ pixel ؤѴ */
static unsigned long get_color_pixel( char *color_name )
{
    Colormap cmap;
    XColor exact_color;
    Status xs;

    cmap = Pc_cmap /* DefaultColormap( Pc_dis, 0 ) */ ;

    exact_color.pixel = 0;
    xs = XParseColor(Pc_dis, cmap, color_name, &exact_color);
    if ( xs == 0 ) {
	fprintf(stderr,"EGGX: [WARNING] XParseColor() failed.\n");
	exact_color.pixel = 0;
	goto quit;
    }
    if ( Pc_depth == 8 ) {	/* 256 */
	get_colorpixel_from_cmap(cmap, &exact_color);
    }
    else {
	int r = exact_color.red >> 8;
	int g = exact_color.green >> 8;
	int b = exact_color.blue >> 8;
	exact_color.pixel  = (r>>(8-Red_depth))<<Red_sft;
	exact_color.pixel |= (g>>(8-Green_depth))<<Green_sft;
	exact_color.pixel |= (b>>(8-Blue_depth))<<Blue_sft;
    }

 quit:
    return ( exact_color.pixel );
}

/* եȥåȤ롥ξϡåϿ */
static XFontSet get_fontset( const char *fontname )
{
    XFontSet rt;
    int mc, i;
    char *ds;
    char **ml = NULL;
    if ( Pc_fscache != NULL ) {
	/* åõ */
	for ( i=0 ; i < Pc_nfscache ; i++ ) {
	    if ( strcmp(Pc_fscache[i].fontname,fontname) == 0 ) {
		rt = Pc_fscache[i].fontset;
		goto quit;
	    }
	}
    }
    /* ˥եȥåȤꡤåϿ */
    rt = XCreateFontSet(Pc_dis,fontname,&ml,&mc,&ds) ;
    if ( rt != NULL ) {
	Pc_fscache = (struct fontsettg *)_eggx_xrealloc(Pc_fscache,
					sizeof(*Pc_fscache)*(Pc_nfscache + 1));
	Pc_fscache[Pc_nfscache].fontname = _eggx_xstrdup(fontname);
	Pc_fscache[Pc_nfscache].fontset = rt;
	Pc_fscache[Pc_nfscache].missing_list = ml;
	Pc_nfscache ++;
    }
    else {
	if ( ml != NULL ) XFreeStringList(ml);
    }

 quit:
    return rt;
}

/* եȥåȤΥå */
/* Xlib ΥХǡˤϳʤorz */
static void free_fontset_cache()
{
    if ( Pc_fscache != NULL ) {
	int i;
	for ( i=0 ; i < Pc_nfscache ; i++ ) {
	    if ( Pc_fscache[i].fontname != NULL )
		free(Pc_fscache[i].fontname);
	    if ( Pc_fscache[i].fontset != NULL )
		XFreeFontSet(Pc_dis, Pc_fscache[i].fontset);
	    if ( Pc_fscache[i].missing_list != NULL )
		XFreeStringList(Pc_fscache[i].missing_list);
	}
	free(Pc_fscache);
	Pc_fscache = NULL;
	Pc_nfscache = 0;
    }
    return;
}

/* ɸѴԤʤؿ */
static void xyconv( int wn, float x, float y, int *rx, int *ry )
{
    float f_rx, f_ry;
    int ry0;
    f_rx = ((x-Pc[wn].winxs)*Pc[wn].wicx);
    f_ry = ((y-Pc[wn].winys)*Pc[wn].wicy);
    if ( f_rx < -32767.0 ) f_rx = -32767.0;
    else if ( 32767.0 < f_rx ) f_rx = 32767.0;
    if ( f_ry < -32767.0 ) f_ry = -32767.0;
    else if ( 32767.0 < f_ry ) f_ry = 32767.0;

    *rx = (int)f_rx;
    ry0 = Pc[wn].wszy - 1 - (int)f_ry;
    if ( 32767 < ry0 ) *ry = 32767;
    else *ry = ry0;
    return;
}

/* ========================== */

static Window XX_CreateSimpleWindow(Display *display, Window parent,
				   int x, int y,
				   unsigned int width, unsigned int height,
				   unsigned int border_width,
				   unsigned long border, 
				   unsigned long background )
{
    XSetWindowAttributes attributes ;

    attributes.border_pixel = border ;
    attributes.background_pixel = background ;
    attributes.colormap = Pc_cmap ;

    return( XCreateWindow(display,parent,x,y,width,height,
			  border_width,
			  Pc_depth,InputOutput,Pc_visual,
			  CWBorderPixel | CWBackPixel | CWColormap,
			  &attributes) ) ;
}

/* ȽλǤ饤(Xк) */
static int XX_DrawLine( Display *dis, int wn, int xs, int ys, int xe, int ye )
{
    int i ;
    i=Pc[wn].wly ;
    XDrawPoint( dis, Pc[wn].pix[i], Pc[wn].gc, xs, ys ) ;
    XDrawLine( dis, Pc[wn].pix[i], Pc[wn].gc, xs,ys,xe,ye ) ;
    XDrawPoint( dis, Pc[wn].pix[i], Pc[wn].gc, xe, ye ) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XDrawPoint( dis, Pc[wn].win, Pc[wn].gc, xs, ys ) ;
    XDrawLine( dis, Pc[wn].win, Pc[wn].gc, xs,ys,xe,ye ) ;
    XDrawPoint( dis, Pc[wn].win, Pc[wn].gc, xe, ye ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XDrawPoint( dis, Pc[wn].iconwin, Pc[wn].gc, xs, ys ) ;
	XDrawLine( dis, Pc[wn].iconwin, Pc[wn].gc, xs,ys,xe,ye ) ;
	XDrawPoint( dis, Pc[wn].iconwin, Pc[wn].gc, xe, ye ) ;
    }
    return(1) ;
}

static int X_DrawLine(  Display *dis, int wn, int xs, int ys, int xe, int ye )
{
    XDrawLine( dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].gc, xs,ys,xe,ye ) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XDrawLine( dis, Pc[wn].win, Pc[wn].gc, xs,ys,xe,ye ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XDrawLine( dis, Pc[wn].iconwin, Pc[wn].gc, xs,ys,xe,ye ) ;
    }
    return(1) ;
}

static int X_DrawPoint( Display *dis, int wn, int x, int y )
{
    XDrawPoint( dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].gc, x, y ) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XDrawPoint( dis, Pc[wn].win, Pc[wn].gc, x, y ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XDrawPoint( dis, Pc[wn].iconwin, Pc[wn].gc, x, y ) ;
    }
    return(1) ;
}

static int X_DrawString( Display *dis, int wn, int x, int y, char *str, int len )
{
    XDrawString( dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].gc, x, y, str, len ) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XDrawString( dis, Pc[wn].win, Pc[wn].gc, x, y, str, len ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XDrawString( dis, Pc[wn].iconwin, Pc[wn].gc, x, y, str, len ) ;
    }
    return(1) ;
}

static int X_mbDrawString( Display *dis, int wn, int x, int y, char *str, int len )
{
    XmbDrawString( dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].fontset, Pc[wn].gc, x, y, str, len ) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XmbDrawString( dis, Pc[wn].win, Pc[wn].fontset, Pc[wn].gc, x, y, str, len ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XmbDrawString( dis, Pc[wn].iconwin, Pc[wn].fontset, Pc[wn].gc, x, y, str, len ) ;
    }
    return(1) ;
}

static int X_FillArc( Display *dis, int wn, int x, int y, 
		      int sx, int sy, int s, int w )
{
    XFillArc( dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].gc, x, y, sx, sy, s, w ) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XFillArc( dis, Pc[wn].win, Pc[wn].gc, x, y, sx, sy, s, w ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XFillArc( dis, Pc[wn].iconwin, Pc[wn].gc, x, y, sx, sy, s, w ) ;
    }
    return(1) ;
}

static int X_DrawArc( Display *dis, int wn, int x, int y, 
		      int sx, int sy, int s, int w )
{
    XDrawArc( dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].gc, x, y, sx, sy, s, w ) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XDrawArc( dis, Pc[wn].win, Pc[wn].gc, x, y, sx, sy, s, w ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XDrawArc( dis, Pc[wn].iconwin, Pc[wn].gc, x, y, sx, sy, s, w ) ;
    }
    return(1) ;
}

static int X_FillPolygon( Display *dis, int wn, XPoint* points, 
			  int num, int shape, int mode )
{
    XFillPolygon( dis,Pc[wn].pix[Pc[wn].wly],Pc[wn].gc,points,num,shape,mode) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XFillPolygon( dis,Pc[wn].win,Pc[wn].gc,points,num,shape,mode) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XFillPolygon( dis,Pc[wn].iconwin,Pc[wn].gc,points,num,shape,mode) ;
    }
    return(1) ;
}

static int X_DrawRectangle( Display *dis, int wn, int x, int y, int w, int h )
{
    XDrawRectangle( dis,Pc[wn].pix[Pc[wn].wly],Pc[wn].gc,x,y,w,h) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XDrawRectangle( dis,Pc[wn].win,Pc[wn].gc,x,y,w,h) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XDrawRectangle( dis,Pc[wn].iconwin,Pc[wn].gc,x,y,w,h) ;
    }
    return(1) ;
}

static int X_FillRectangle( Display *dis, int wn, int x, int y, int w, int h )
{
    XFillRectangle( dis,Pc[wn].pix[Pc[wn].wly],Pc[wn].gc,x,y,w,h) ;
    if( Pc[wn].wly!=Pc[wn].sly ) return(0) ;
    XFillRectangle( dis,Pc[wn].win,Pc[wn].gc,x,y,w,h) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XFillRectangle( dis,Pc[wn].iconwin,Pc[wn].gc,x,y,w,h) ;
    }
    return(1) ;
}

/* ========================== */

static int bitcount( int d )
{
    int rt=0 ;
    while( (d & 0x01)==0x01 ){
	d>>=1 ;
	rt++ ;
    }
    return(rt) ;
}
static int sftcount( int *mask )
{
    int rt=0 ;
    while( (*mask & 0x01)==0 ){
	(*mask)>>=1 ;
	    rt++ ;
    }
    return(rt) ;
}


/*  */
/*            󶡤ؿ            */
/*  */

/* եå⡼ɤԤʤ */
void eggx_gsetnonflush( int flag )
{
    if ( flag == ENABLE ) {
	Pc_nonflush = ENABLE;
    }
    else {
	Pc_nonflush = DISABLE;
    }
    return;
}

void gsetnonflush_( integer *flag )
{
    int i_flag = *flag;
    eggx_gsetnonflush(i_flag);
    return;
}

int eggx_ggetnonflush( void )
{
    return Pc_nonflush;
}

void ggetnonflush_( integer *flag )
{
    *flag = Pc_nonflush;
    return;
}

/* ưflushԤʤ */
void eggx_gflush( void )
{
    if ( Pc_dis != NULL ) XFlush( Pc_dis );
    return;
}

void gflush_( void )
{
    eggx_gflush();
    return;
}

/* displayopendepthʤɤĴ٤ */
int eggx_ggetdisplayinfo( int *rt_depth, int *root_width, int *root_height )
{
    Window lwin ;
    static XWindowAttributes xvi,root_xvi ;
    XVisualInfo visual_info ;
    int i,best,num_visual ;

    if( Pc_dis==NULL ){
	Pc_dis=XOpenDisplay(NULL) ;
	if( Pc_dis==NULL ){
	    if( rt_depth != NULL ) *rt_depth=-1 ;
	    if( root_width != NULL ) *root_width=-1 ;
	    if( root_height != NULL ) *root_height=-1 ;
	    return(-1) ;
	}
	/* Visualη */
	visual_info.screen = DefaultScreen(Pc_dis) ;
	visual_info.class  = TrueColor ;

	if( Pc_vinfo_ptr!=NULL ) XFree((char *)Pc_vinfo_ptr) ;
	Pc_vinfo_ptr = XGetVisualInfo( Pc_dis, 
				       VisualScreenMask | VisualClassMask,
				       &visual_info, &num_visual ) ;
	best = -1 ;
	if( Pc_vinfo_ptr!=NULL ){     /* TrueColorõ */
	    for( i=0 ; i < num_visual ; i++ ){
		if( 0 <= best ){
		    if( Pc_vinfo_ptr[best].depth < Pc_vinfo_ptr[i].depth ){
			if( Pc_vinfo_ptr[i].depth <= 24 ){
			    best = i ;
			}
		    }
		}
		else{
		    best = i ;
		}
	    }
	}
	if( 0 <= best ){	/* Ʊʤ */
	    if( Pc_vinfo_ptr[best].depth 
		== DefaultDepth(Pc_dis,DefaultScreen(Pc_dis)) )
		best=-1 ;
	}
	if( best == -1 ){
	    Pc_visual=DefaultVisual(Pc_dis,DefaultScreen(Pc_dis));
	    Pc_depth =DefaultDepth(Pc_dis,DefaultScreen(Pc_dis));
	    Pc_cmap  =DefaultColormap(Pc_dis,DefaultScreen(Pc_dis));
	    if( Pc_vinfo_ptr!=NULL ){
		XFree((char *)Pc_vinfo_ptr) ;
		Pc_vinfo_ptr=NULL ;
	    }
	}
	else{
	    Pc_visual=Pc_vinfo_ptr[best].visual ;
	    Pc_depth =Pc_vinfo_ptr[best].depth ;
	    Pc_cmap  =XCreateColormap(Pc_dis, 
				      DefaultRootWindow(Pc_dis),
				      Pc_visual, AllocNone);
	}

	/* ˥ߡΥɥä */
	lwin = XX_CreateSimpleWindow( Pc_dis, RootWindow(Pc_dis,0), 
				      0, 0, 16, 16, 0, WhitePixel(Pc_dis,0), 
				      BlackPixel(Pc_dis,0) ) ;
	/* °Ĵ٤ */
	XGetWindowAttributes( Pc_dis, RootWindow(Pc_dis,0) , &root_xvi ) ;
	XGetWindowAttributes( Pc_dis, lwin, &xvi ) ;
	if( Pc_depth != xvi.depth ){
	    fprintf(stderr,
		    "EGGX: [WARNING] Detected invalid depth of X server!!\n") ;
	    Pc_depth = xvi.depth ;
	}
	if( 16<=Pc_depth ){
	    Red_depth=(xvi.visual)->red_mask ;
	    Green_depth=(xvi.visual)->green_mask ;
	    Blue_depth=(xvi.visual)->blue_mask ;
	    /* եȤβ */
	    Red_sft=sftcount(&(Red_depth)) ;
	    Green_sft=sftcount(&(Green_depth)) ;
	    Blue_sft=sftcount(&(Blue_depth)) ;
	    /* ӥåȤο */
	    Red_depth=bitcount(Red_depth) ;
	    Green_depth=bitcount(Green_depth) ;
	    Blue_depth=bitcount(Blue_depth) ;
	    /*
	    printf("%d %d %d - %d %d %d\n",Red_sft,Green_sft,Blue_sft,
		   Red_depth,Green_depth,Blue_depth) ;
	    */
	}
	XDestroyWindow( Pc_dis, lwin ) ;
    }
    if( rt_depth != NULL ) *rt_depth = Pc_depth ;
    if( root_width != NULL ) *root_width  = root_xvi.width ;
    if( root_height != NULL ) *root_height = root_xvi.height ;
    return( 0 ) ;
}

void ggetdisplayinfo_( integer *rt_d, integer *root_w, integer *root_h )
{
    int rt_depth,root_width,root_height ;
    eggx_ggetdisplayinfo(&rt_depth,&root_width,&root_height) ;
    *rt_d   = rt_depth ;
    *root_w = root_width ;
    *root_h = root_height ;
}

/* 򳫤 */
void gopen_( integer *xsize, integer *ysize, integer *rtnum )
{
    char int_1[] = "1" ;
    char str_white[] = "White";
    XGCValues gv ;
    XEvent ev ;				/* ٥ȼѿ */
    XSetWindowAttributes att ;		/* °ѿ */
    XClassHint classHint ;
    XSizeHints size_hints = { 0 } ;
    int x_negative=0,y_negative=0 ;
    /* XTextProperty name ; */
    int i,dummy,result,num=0 ;
    int default_depth,root_width,root_height ;
#if 0
    int f ;
#endif

    if( Wn < 0 ){
	if( Pc_dis==NULL ){	/* XserverȤ³ */
	    if( eggx_ggetdisplayinfo(&default_depth,&root_width,&root_height) ){
		fprintf(stderr,"EGGX: [ERROR] Cannot open display.\n") ;
		exit(1) ;
	    }
	}
	if( Wn == -1 ){		/* 1󤭤μ¹ */
	    Pid=getpid() ;
#if 0
	    f=rmproperexec() ;	/* Υƥݥե */
	    if( f ){
	      fprintf(stderr,"ٹ: /tmp ǥ쥯ȥ꤬ץǤޤ\n") ;
	    }
#endif
	    /* atexit( &rmexecfile ) ; */
#ifdef CYGWIN
	    atexit( &remove_removelist ) ;
#endif
	    atexit( &killallchld ) ;
	    Pname = _eggx_getpname(Pid) ;
	    if( Pname == NULL ) Pname = _Pname ;
	    if( setlocale(LC_CTYPE, "") == NULL /* && 0 */ )
		fprintf(stderr,"EGGX: [WARNING] Cannot set locale.\n") ;
	    /* atexit( &eggx_gcloseall ) ; */
	}
	/* ߥϥɥϿ */
	iusr_start() ;
	Wn = 0 ;
    }

    wait_child() ;			/* imgsaveԤ */

    if( N_Pc == 0 ){
	struct pctg *new_pc;
	int new_n;
	new_n = PC_UNITLEN ;
	new_pc = (struct pctg *)_eggx_xmalloc(sizeof(struct pctg)*new_n) ;
	for( i=0 ; i < new_n ; i++ ){
	    new_pc[i].flg=0 ;
	    new_pc[i].cpid=0 ;
	    new_pc[i].fsz=-1 ;
	    new_pc[i].fontstruct = NULL ;
	}
	/* ߥϥɥˤ뻲ȤͤơϿϺǸ˹Ԥʤ */
	Pc = new_pc;
	N_Pc = new_n;
    }
    if( rtnum==NULL ){			/* plots褿 */
	if( Pc[0].flg==1 ) return ;	/* Ǥ˥ץѤ */
	num = 0 ;
	Pc[0].flg=1 ;
    }
    else{				/* Ƥֹõ */
	for( i=1 ; i < N_Pc ; i++ ){	/* 0plotsѤͽ*/
	    if( Pc[i].flg==0 ){
		num = i ;
		Pc[i].flg=1 ;
		break ;
	    }
	}
	if( i == N_Pc ){		/* Ƥʤ */
	    struct pctg *new_pc;
	    struct pctg *old_pc;
	    int new_n, old_n;
	    old_n = N_Pc ;
	    new_n = N_Pc + PC_UNITLEN ;
	    old_pc = Pc ;
	    /*  realloc ȤäƤϤʤ */
	    new_pc = (struct pctg *)_eggx_xmalloc(sizeof(struct pctg)*new_n) ;
	    memcpy(new_pc, old_pc, sizeof(struct pctg)*old_n) ;
	    for( i=old_n ; i < new_n ; i++ ){
		new_pc[i].flg=0 ;
		new_pc[i].cpid=0 ;
		new_pc[i].fsz=-1 ;
		new_pc[i].fontstruct = NULL ;
	    }
	    /* ߥϥɥˤ뻲ȤͤơϿϺǸ˹Ԥʤ */
	    Pc = new_pc ;
	    N_Pc = new_n ;
	    free(old_pc) ;	/* ǸκǸ free()  */
	    /* */
	    num = old_n ;
	    Pc[old_n].flg = 1 ;
	}
    }
    Pc[num].wly=0 ;
    Pc[num].sly=0 ;

    Pc[num].attributes = Pc_attributes ;

    size_hints.flags = 0 ;
    if( Pc_geometry != NULL ){
	unsigned int size_hints__width,size_hints__height ;
	result = XParseGeometry( Pc_geometry, 
				 &size_hints.x,
				 &size_hints.y,
				 &size_hints__width,
				 &size_hints__height ) ;
	size_hints.width = (int)size_hints__width ;
	size_hints.height = (int)size_hints__height ;
	if( result & XNegative ) x_negative = 1 ;
	if( result & YNegative ) y_negative = 1 ;
	
        size_hints.flags |= USPosition ;
        size_hints.x = 0;
        size_hints.y = 0;

	XWMGeometry( Pc_dis, DefaultScreen(Pc_dis), 
		     Pc_geometry, NULL, 
		     Pc_bdr_width, &size_hints,
		     &size_hints.x, &size_hints.y,
		     &size_hints.width, &size_hints.height, 
		     &dummy );

	size_hints.flags |= PMinSize ;
	size_hints.min_width = *xsize ;
	size_hints.min_height = *ysize ;
	
	size_hints.flags |= PMaxSize ;
	size_hints.max_width = *xsize ;
	size_hints.max_height = *ysize ;
	
	size_hints.flags |= USSize ;
	size_hints.width = *xsize ;
	size_hints.height = *ysize ;
	
	size_hints.win_gravity = NorthWestGravity ;
	if( x_negative ){
	    size_hints.x -= size_hints.width ;
	    size_hints.win_gravity = NorthEastGravity ;
	}
	if( y_negative ){
	    size_hints.y -= size_hints.height ;
	    if( x_negative )
		size_hints.win_gravity = SouthEastGravity ;
	    else
		size_hints.win_gravity = SouthWestGravity ;
	}
	size_hints.flags |= PWinGravity;
    }
    else{
	size_hints.x = 0 ;
	size_hints.y = 0 ;

	size_hints.flags |= PMinSize ;
	size_hints.min_width = *xsize ;
	size_hints.min_height = *ysize ;
	
	size_hints.flags |= PMaxSize ;
	size_hints.max_width = *xsize ;
	size_hints.max_height = *ysize ;
	
	size_hints.flags |= USSize ;
	size_hints.width = *xsize ;
	size_hints.height = *ysize ;
    }

    if( Pc_bgcolor == NULL ){
	Pc[num].bgcolor = BlackPixel(Pc_dis,0) ;
    }
    else{
	Pc[num].bgcolor = get_color_pixel(Pc_bgcolor) ;
    }

    /*  */
    Pc[num].win = XX_CreateSimpleWindow( Pc_dis, RootWindow(Pc_dis,0), 
					 size_hints.x, size_hints.y,
					 *xsize, *ysize, Pc_bdr_width, WhitePixel(Pc_dis,0), 
				       Pc[num].bgcolor ) ;
    XSetWMNormalHints( Pc_dis, Pc[num].win, &size_hints) ;
    if( Pc[num].attributes & DOCKAPP ){
	XWMHints mywmhints ;
	Pc[num].iconwin = XX_CreateSimpleWindow( Pc_dis, RootWindow(Pc_dis,0), 
						 size_hints.x, size_hints.y,
						 *xsize, *ysize, Pc_bdr_width, WhitePixel(Pc_dis,0), 
					       Pc[num].bgcolor ) ;
	XSetWMNormalHints( Pc_dis, Pc[num].iconwin, &size_hints ) ;
	mywmhints.initial_state = WithdrawnState ;
        mywmhints.icon_window = Pc[num].iconwin ;
        mywmhints.icon_x = size_hints.x ;
        mywmhints.icon_y = size_hints.y ;
        mywmhints.window_group = Pc[num].win ;
        mywmhints.flags = StateHint | IconWindowHint | 
	    IconPositionHint | WindowGroupHint ;
	XSetWMHints( Pc_dis, Pc[num].win, &mywmhints ) ;
    }
    else Pc[num].iconwin = 0 ;

    Pc[num].pix[0] = XCreatePixmap( Pc_dis,Pc[num].win,*xsize,*ysize,Pc_depth ) ;

    Pc[num].pix[1] = XCreatePixmap( Pc_dis,Pc[num].win,*xsize,*ysize,Pc_depth ) ;

    gv.fill_style = FillTiled ;
    gv.fill_rule = WindingRule ;
    gv.tile = Pc[num].pix[1] ;
    Pc[num].pxgc = XCreateGC( Pc_dis,Pc[num].win,GCFillStyle|GCFillRule|GCTile,&gv ) ;
    
    /* ¸򤹤 */
    /* att.backing_store = WhenMapped ; */
    /* XФô򸺤餹ᡤҥץκ */
    /*
    att.backing_store = NotUseful ;
    XChangeWindowAttributes( Pc_dis, Pc[num].win, CWBackingStore, &att ) ;
    */


    /* ɥȤĤʤ */
    if( Pc[num].attributes & OVERRIDE ){
	att.override_redirect = True ;
	XChangeWindowAttributes( Pc_dis, Pc[num].win, CWOverrideRedirect, &att ) ;
    }

    if( Pc_storename != NULL )
	XStoreName( Pc_dis, Pc[num].win, Pc_storename ) ;
    else
	XStoreName( Pc_dis, Pc[num].win, Pname ) ;
    if( Pc_iconname != NULL )
	XSetIconName( Pc_dis, Pc[num].win, Pc_iconname ) ;
    else
	XSetIconName( Pc_dis, Pc[num].win, Pname ) ;
    if( Pc_classhint_res_name != NULL )
	classHint.res_name = Pc_classhint_res_name ;
    else classHint.res_name = Pname ;
    if( Pc_classhint_res_class != NULL ){
	classHint.res_class = Pc_classhint_res_class ;
	XSetClassHint( Pc_dis, Pc[num].win , &classHint);
    }
    else{
	classHint.res_class = _eggx_xstrdup_toupper(Pname) ;
	XSetClassHint( Pc_dis, Pc[num].win , &classHint);
	free(classHint.res_class) ;
    }

    if( Pc[num].attributes & DOCKAPP ){
	if( Pc_storename != NULL )
	    XStoreName( Pc_dis, Pc[num].iconwin, Pc_storename ) ;
	else
	    XStoreName( Pc_dis, Pc[num].iconwin, Pname ) ;
	if( Pc_iconname != NULL )
	    XSetIconName( Pc_dis, Pc[num].iconwin, Pc_iconname ) ;
	else
	    XSetIconName( Pc_dis, Pc[num].iconwin, Pname ) ;
	if( Pc_classhint_res_name != NULL )
	    classHint.res_name = Pc_classhint_res_name ;
	else classHint.res_name = Pname ;
	if( Pc_classhint_res_class != NULL ){
	    classHint.res_class = Pc_classhint_res_class ;
	    XSetClassHint( Pc_dis, Pc[num].iconwin , &classHint);
	}
	else{
	    classHint.res_class = _eggx_xstrdup_toupper(Pname) ;
	    XSetClassHint( Pc_dis, Pc[num].iconwin , &classHint);
	    free(classHint.res_class) ;
	}
    }

    /*
    if( XStringListToTextProperty(&Pname, 1, &name) != 0 ){
	XSetWMName( Pc_dis, Pc[num].win, &name);
    }
    */
    XSelectInput( Pc_dis, Pc[num].win, ExposureMask ) ;
    if( Pc[num].attributes & DOCKAPP ){
	XSelectInput( Pc_dis, Pc[num].iconwin, ExposureMask ) ;
    }
    XMapWindow( Pc_dis, Pc[num].win ) ;	/* ɽ */
    
    do{					/* 뤬Ԥĥ롼 */
	XNextEvent( Pc_dis, &ev ) ;
    } while( ev.type != Expose ) ;

    if( Pc[num].attributes & DOCKAPP ){
	XSelectInput( Pc_dis, Pc[num].iconwin, 0 ) ;
    }

    Pc[num].gc = XCreateGC( Pc_dis, Pc[num].win,0,0 ) ;
    Pc[num].bggc = XCreateGC( Pc_dis, Pc[num].win,0,0 ) ;
    /* XSetGraphicsExposures( Pc_dis, Pc[num].gc, False ) ; */
    
    XSetForeground( Pc_dis, Pc[num].bggc, Pc[num].bgcolor ) ;
    XFillRectangle( Pc_dis, Pc[num].pix[0], Pc[num].bggc, 0,0,*xsize,*ysize ) ;
    XFillRectangle( Pc_dis, Pc[num].pix[1], Pc[num].bggc, 0,0,*xsize,*ysize ) ;
    XDrawRectangle( Pc_dis, Pc[num].pix[0], Pc[num].bggc, 0,0,*xsize,*ysize ) ;
    XDrawRectangle( Pc_dis, Pc[num].pix[1], Pc[num].bggc, 0,0,*xsize,*ysize ) ;

    XSetForeground( Pc_dis, Pc[num].gc, get_color_pixel(str_white) ) ;

    /* եȥå */
    Pc[num].fontset = NULL ;
    
    XFlush( Pc_dis ) ;			/* ꥯȤζ */

    Pc[num].wszx = *xsize ;		/* եå */
    Pc[num].wszy = *ysize ;
    Pc[num].winxs = 0.0 ;		/* ɥ */
    Pc[num].winxe = (*xsize)-1 ;
    Pc[num].winys = 0.0 ;
    Pc[num].winye = (*ysize)-1 ;
    Pc[num].wicx = 1 ;
    Pc[num].wicy = 1 ;

    if( rtnum!=NULL ) *rtnum=num ;

    XSelectInput( Pc_dis, Pc[num].win, 0 ) ;

    if( Pc[num].attributes & AUTOREDRAW ){
	/* pid_t cpid ; */
	char arg2[16] ;
	char arg3[16],arg4[16] ;
	char arg5[16],arg6[16] ;
	char arg7[16],arg8[16] ;
	char arg9[16] ;
	char *args[11] ;
	sprintf(arg2,"%ld",(long)Pid) ;
	sprintf(arg3,"%ld",(Pc[num].attributes & DOCKAPP)) ;
	sprintf(arg4,"%ld",Pc[num].win) ;
	sprintf(arg5,"%ld",Pc[num].iconwin) ;
	sprintf(arg6,"%ld",Pc[num].pix[0]) ;
	sprintf(arg7,"%ld",Pc[num].pix[1]) ;
	sprintf(arg8,"%d",Pc[num].wszx) ;
	sprintf(arg9,"%d",Pc[num].wszy) ;
	args[0]=Exec_slave_tmp ;
	args[1]=int_1 ;
	args[2]=arg2 ;
	args[3]=arg3 ;
	args[4]=arg4 ;
	args[5]=arg5 ;
	args[6]=arg6 ;
	args[7]=arg7 ;
	args[8]=arg8 ;
	args[9]=arg9 ;
	args[10]=NULL ;
	while(1){
	    if( mkexecfile() == -1 ){
		fprintf(stderr,
			"EGGX: [WARNING] Cannot create a file in /tmp/.\n") ;
		Pc[num].cpid=0 ;
		break ;
	    }
	    if( Exec_fd != -1 ){
		close(Exec_fd) ;
		Exec_fd=-1 ;
	    }
	    /* δ֤ǥե뤬äȡĻҤޤʤΤǡ */
	    /* 롼פκǸmkexecfile */
	    if( (Pc[num].cpid=(Cpid_tmp=fork()))<0 ){
		fprintf(stderr,"EGGX: [ERROR] fork() failed.\n") ;
		exit(-1) ;
	    }
	    if( Cpid_tmp==0 ){	/*  */
		/* fprintf(stderr,"execv: ppid=%d pid=%d\n",getppid(),getpid()) ; */
		if( execv(*args,args)==-1 ){
		    if( Pid == getppid() )
			kill(Pid,SIGUSR2) ;	/* 顼Τ */
		    /*
		    fprintf(stderr,"ppid=%d pid=%d ե %s ¹ԤǤޤ\n",
			    getppid(),getpid(),*args) ;
		    */
		    _exit(-1) ;
		}
	    }
	    /* Ƣ */
	    while( Bsyflg==0 ){		/*  imgsaveǻȤե饰ή  */
		eggx_msleep( 10 ) ;
	    }
	    if( Bsyflg==1 ){		/* ưǤʤϡBsyflg==-1 ˤʤ */
		rmexecfile() ;
		Bsyflg=0 ;
		break ;
	    }
	    else{	/* Bsyflg==-1 */
		i=0 ;
		while( Cpid_tmp != 0 ){
		    /* fprintf(stderr,"waiting...Pid=%d cpid=%d \n",Pid,Cpid_tmp) ; */
		    if( i==10 ){
			i=0 ;
			/* fprintf(stderr,"check child = %d\n",kill(0,Cpid_tmp)) ; */
			if( kill(0,Cpid_tmp) ){
			    /* Strange, but he died... */
			    break ;
			}
		    }
		    eggx_msleep( 10 ) ;
		    i++ ;
		}
		Bsyflg=0 ;
	    }
	} 
    }
    else{
	Pc[num].cpid=0 ;
    }

    if ( Pc_nonblock == ENABLE ) {
	XSelectInput( Pc_dis, Pc[num].win, 
		      ButtonPressMask | KeyPressMask | PointerMotionMask );
    }

    return;
}

void plots_( void )
{
    integer x=640,y=400 ;
    gopen_( &x, &y, NULL ) ;
}

int eggx_gopen( int xsize, int ysize )
{
    integer rtnum,xs,ys ;
    xs=(integer)xsize ;
    ys=(integer)ysize ;
    gopen_( &xs, &ys, &rtnum ) ;
    return( (int)rtnum ) ;
}

void eggx_gsetinitialattributes( int flag, long att )
{
    if( flag == ENABLE ){
	Pc_attributes |= att ;
    }
    else if( flag == DISABLE ){
	Pc_attributes &= ~att ;
    }
}

void eggx_gsetborder( int wn, int width, const char *argsformat, ... )
{
    int fl = 0;
    unsigned long pix;
    char *color = NULL;
    va_list ap;

    if ( 0 <= width ) {
	XSetWindowBorderWidth( Pc_dis, Pc[wn].win, width );
	if ( Pc[wn].attributes & DOCKAPP ) {
	    XSetWindowBorderWidth( Pc_dis, Pc[wn].iconwin, width );
	}
	fl = 1;
    }

    if ( argsformat != NULL ) {
	va_start(ap, argsformat);
	color = _eggx_vasprintf(argsformat,ap);
	va_end(ap);

	pix = get_color_pixel( color );
	XSetWindowBorder( Pc_dis, Pc[wn].win, pix );
	if ( Pc[wn].attributes & DOCKAPP ) {
	    XSetWindowBorder( Pc_dis, Pc[wn].iconwin, pix );
	}
	fl = 1;
    }
    if ( fl ) do_auto_flush();
    if ( color != NULL ) free(color);
    return;
}

void eggx_gsetinitialborder( int width, const char *argsformat, ... )
{
    va_list ap;
    
    if ( 0 <= width ) Pc_bdr_width = width;
    
    if ( argsformat != NULL ) {
	if ( Pc_bordercolor != NULL ) {
	    free(Pc_bordercolor);
	    Pc_bordercolor = NULL;
	}
	va_start(ap, argsformat);
	Pc_bordercolor = _eggx_vasprintf(argsformat,ap);
	va_end(ap);
    }
    /*
    else{
	if( Pc_bgcolor != NULL ){
	    free(Pc_bordercolor) ;
	    Pc_bordercolor = NULL ;
	}
    }
    */
    return;
}

void eggx_gsetbgcolor( int wn, const char *argsformat, ... )
{
    char *color = NULL;
    va_list ap;

    if ( argsformat != NULL ) {
	va_start(ap, argsformat);
	color = _eggx_vasprintf(argsformat,ap);
	va_end(ap);

	Pc[wn].bgcolor = get_color_pixel(color);
	XSetForeground( Pc_dis, Pc[wn].bggc, Pc[wn].bgcolor );
	XSetWindowBackground( Pc_dis, Pc[wn].win, Pc[wn].bgcolor );
	if ( Pc[wn].attributes & DOCKAPP ) {
	    XSetWindowBackground( Pc_dis, Pc[wn].iconwin, Pc[wn].bgcolor );
	}
    }
    if ( color != NULL ) free(color);
    return;
}

void gsetbgcolor_( integer *wn, char *colorname )
{
    eggx_gsetbgcolor( *wn, colorname ) ;
}

void eggx_gsetinitialbgcolor( const char *argsformat, ... )
{
    va_list ap;

    if ( Pc_bgcolor != NULL ) {
	free(Pc_bgcolor);
	Pc_bgcolor = NULL;
    }
    if ( argsformat != NULL ) {
	va_start(ap, argsformat);
	Pc_bgcolor = _eggx_vasprintf(argsformat,ap);
	va_end(ap);
    }

    return;
}

void eggx_gsetinitialparsegeometry( const char *argsformat, ... )
{
    va_list ap;

    if ( Pc_geometry != NULL ) {
	free(Pc_geometry);
	Pc_geometry = NULL;
    }
    if ( argsformat != NULL ) {
	va_start(ap, argsformat);
	Pc_geometry = _eggx_vasprintf(argsformat,ap);
	va_end(ap);
    }

    return;
}

void eggx_gsetinitialwinname( const char *storename, const char *iconname,
			      const char *resname, const char *classname )
{
    if( Pc_storename!=NULL ){
	free(Pc_storename) ;
	Pc_storename=NULL ;
    }
    if( Pc_iconname!=NULL ){
	free(Pc_iconname) ;
	Pc_iconname=NULL ;
    }
    if( Pc_classhint_res_name!=NULL ){
	free(Pc_classhint_res_name) ;
	Pc_classhint_res_name=NULL ;
    }
    if( Pc_classhint_res_class!=NULL ){
	free(Pc_classhint_res_class) ;
	Pc_classhint_res_class=NULL ;
    }

    if( storename != NULL )
	Pc_storename = _eggx_xstrdup(storename) ;
    if( iconname != NULL )
	Pc_iconname = _eggx_xstrdup(iconname) ;
    if( resname != NULL )
	Pc_classhint_res_name = _eggx_xstrdup(resname) ;
    if( classname != NULL )
	Pc_classhint_res_class = _eggx_xstrdup(classname) ;
}

void gsetinitialwinname_( char *storename, char *iconname,
			  char *resname, char *classname )
{
    eggx_gsetinitialwinname( storename, iconname,
			     resname, classname ) ;
}

int eggx_winname( int wn, const char *argsformat, ... )
{
    char *name = NULL;
    int nn = -1;
    va_list ap;

    if ( argsformat == NULL ) goto quit;

    va_start(ap, argsformat);
    name = _eggx_vasprintf(argsformat,ap);
    va_end(ap);

    nn = strlen(name);

    XStoreName( Pc_dis, Pc[wn].win, name ) ;
    XSetIconName( Pc_dis, Pc[wn].win, name ) ;
    if( Pc[wn].attributes & DOCKAPP ){
	XStoreName( Pc_dis, Pc[wn].iconwin, name ) ;
	XSetIconName( Pc_dis, Pc[wn].iconwin, name ) ;
    }
    do_auto_flush() ;

 quit:
    if ( name != NULL ) free(name);
    return (nn);
}

/* ɥ̾ */
void winname_( integer *wn, char *name )
{
    XStoreName( Pc_dis, Pc[*wn].win, name ) ;
    XSetIconName( Pc_dis, Pc[*wn].win, name ) ;
    if( Pc[*wn].attributes & DOCKAPP ){
	XStoreName( Pc_dis, Pc[*wn].iconwin, name ) ;
	XSetIconName( Pc_dis, Pc[*wn].iconwin, name ) ;
    }
    do_auto_flush() ;
}

/* Windowꤹ[0] */
void eggx_window( int wn, float xs, float ys, float xe, float ye )
{
    Pc[wn].winxs=xs ;
    Pc[wn].winxe=xe ;
    Pc[wn].winys=ys ;
    Pc[wn].winye=ye ;
    if( Pc[wn].wszx <= 1 ) Pc[wn].wicx = 1 ;
    else Pc[wn].wicx = (float)Pc[wn].wszx/ 
	     ((float)(Pc[wn].wszx)*(Pc[wn].winxe-Pc[wn].winxs)/(float)(Pc[wn].wszx-1))  ;
    if( Pc[wn].wszy <= 1 ) Pc[wn].wicy = 1 ;
    else Pc[wn].wicy = (float)Pc[wn].wszy/
	     ((float)(Pc[wn].wszy)*(Pc[wn].winye-Pc[wn].winys)/(float)(Pc[wn].wszy-1))  ;
}

void newwindow_( integer *wn, real *xs, real *ys, real *xe, real *ye )
{
    eggx_window( *wn, *xs, *ys, *xe, *ye ) ;
}

/* Windowꤹ(ߴroutine) */
void window_( real *xs, real *ys, real *xe, real *ye )
{
    eggx_window( Wn,*xs,*ys,*xe,*ye ) ;
}

void vport_( real *x0, real *y0, real *x1, real *y1 )
{
}

void setal_( integer *x, integer *y )
{
}

/* üΥꥢ */
void eggx_tclr( void )
{
    printf("\033[H\033[2J") ;
    fflush(stdout) ;
}

void tclr_()
{
    printf("\033[H\033[2J") ;
    fflush(stdout) ;
}

void clsc_()
{
    printf("\033[H\033[2J") ;
    fflush(stdout) ;
}

/* Ĥ */
void eggx_gclose( int wn )
{
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    if ( 0 < Pc[wn].cpid ) {
	kill(Pc[wn].cpid,SIGTERM) ;
	while ( 0 < Pc[wn].cpid ) {
	    eggx_msleep( 10 ) ;
	}
    }
    XDestroyWindow( Pc_dis, Pc[wn].win ) ;
    if ( Pc[wn].attributes & DOCKAPP )
	XDestroyWindow( Pc_dis, Pc[wn].iconwin ) ;
    XFreePixmap( Pc_dis, Pc[wn].pix[0] ) ;
    XFreePixmap( Pc_dis, Pc[wn].pix[1] ) ;
    XFreeGC( Pc_dis, Pc[wn].pxgc ) ;
    XFreeGC( Pc_dis, Pc[wn].bggc ) ;
    XFreeGC( Pc_dis, Pc[wn].gc ) ;
    Pc[wn].fontset = NULL;
    if ( Pc[wn].fontstruct != NULL ) {
	XFreeFont(Pc_dis,Pc[wn].fontstruct) ;
	Pc[wn].fontstruct = NULL ;
    }
    Pc[wn].fsz=-1;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
    Pc[wn].flg = 0 ;
}

void gclose_( integer *wn )
{
    eggx_gclose( *wn ) ;
}

/* ٤ƤĤơXФǤ */
void eggx_gcloseall( void )
{
    int i;

    /* ³Ƥʤ */
    if ( Wn < 0 ) return;
    if ( getpid() != Pid ) return;

    wait_child();	/* imgsaveԤ */

    /* ٤ƤĤƤ */
    for ( i=0 ; i < N_Pc ; i++ ) {
	if ( Pc[i].flg != 0 ) {
	    eggx_gclose(i);
	}
    }
#ifdef CYGWIN
    remove_removelist();
#endif
    /* ߥϥɥ鸵᤹ */
    iusr_end();
    /* եȥåȤΥå */
    free_fontset_cache();
    /* cmapơ֥γ */
    free_cmap_table();
    /* */
    if ( Pc_cmap != DefaultColormap(Pc_dis,DefaultScreen(Pc_dis)) ) {
	XFreeColormap(Pc_dis,Pc_cmap);
    }
    if ( Pc_vinfo_ptr != NULL ) {
	XFree((char *)Pc_vinfo_ptr);
	Pc_vinfo_ptr = NULL;
    }
    XCloseDisplay( Pc_dis );	/* Xserver */
    Pc_dis = NULL;
    if ( 0 < N_Pc ) {		/* ɥѥХåեⳫ */
	N_Pc = 0;
	free(Pc);
	Pc = NULL;
    }
    Wn = -2;

    return;
}

void gcloseall_( void )
{
    eggx_gcloseall();
    return;
}

/* 򤹤 */
void selwin_( integer *wn )
{
    if ( 0 <= *wn ) Wn = *wn ;
}

/* RGBǿꤹ */
void eggx_newrgbcolor( int wn, int r, int g, int b )
{
    XColor exact_color;
    Colormap cmap;
    unsigned long pxl;

    cmap = Pc_cmap /* DefaultColormap( dis, 0 ) */ ;

    if ( r < 0 ) r = 0;
    if ( g < 0 ) g = 0;
    if ( b < 0 ) b = 0;
    if ( r > 255 ) r = 255;
    if ( g > 255 ) g = 255;
    if ( b > 255 ) b = 255;

    wait_child();
    Ihflg=1;
    if ( Pc_depth == 8 ) {	/* 256顼ޥåפϿ */
	exact_color.green = g << 8;
	exact_color.red   = r << 8;
	exact_color.blue  = b << 8;
	get_colorpixel_from_cmap(cmap, &exact_color);
	pxl = exact_color.pixel;
    }
    else{
	pxl  = (r>>(8-Red_depth))<<Red_sft;
	pxl |= (g>>(8-Green_depth))<<Green_sft;
	pxl |= (b>>(8-Blue_depth))<<Blue_sft;
    }
    XSetForeground( Pc_dis, Pc[wn].gc, pxl );
    Ihflg=0;
    chkexit();
}

void newrgbcolor_( integer *wn, integer *pr, integer *pg, integer *pb )
{
    eggx_newrgbcolor( *wn, *pr, *pg, *pb ) ;
}

/* HSVǿꤹ */
/* @Իؤ餤ޤ :-) */
void eggx_newhsvcolor( int win, int h, int s, int v )
{
    int c1, c2, c3, r, g, b, t;

    if ( s == 0 ) {
	r = v;
	g = v;
	b = v;
    } else {
	t  = (h*6) % 360;
	c1 = (v*(255-s))/255;
	c2 = (v*(255-(s*t)/360))/255;
	c3 = (v*(255-(s*(360-t))/360))/255;
	switch (h/60) {
	case 0: 
	    r=v; g=c3; b=c1;
	    break;
	case 1: 
	    r=c2; g=v; b=c1;
	    break;
	case 2: 
	    r=c1; g=v; b=c3;
	    break;
	case 3: 
	    r=c1; g=c2; b=v;
	    break;
	case 4:
	    r=c3; g=c1; b=v;
	    break;
	default: /* should be 5 */
	    r=v; g=c1; b=c2;
	    break;
	}
    }
    eggx_newrgbcolor(win, r, g, b);
    return;
}

void newhsvcolor_( integer *wn, integer *ph, integer *ps, integer *pv )
{
    eggx_newhsvcolor( *wn, *ph, *ps, *pv ) ;
}

/* ľܿꤹ[1] */
void eggx_newcolor( int wn, const char *argsformat, ... )
{
    char *color = NULL;
    va_list ap;

    if( argsformat != NULL ){
	va_start(ap, argsformat);
	color = _eggx_vasprintf(argsformat,ap);
	va_end(ap);

	wait_child() ;	/* imgsaveԤ */
	Ihflg=1 ;	/* ߶ػ */
	XSetForeground( Pc_dis, Pc[wn].gc, get_color_pixel( color ) ) ;
	Ihflg=0 ;	/* ߶ػ߲ */
    }

    if ( color != NULL ) free(color);
    chkexit();
    return;
}

void newcolor_( integer *wn, char *color )
{
    eggx_newcolor( *wn, color ) ;
}

/* ꤹ[2] */
void eggx_newpen( int wn, int n )
{
    /* { "Black","White","Red","Green",
         "Blue","Cyan","Magenta","Yellow",
         "DimGray","Grey","red4","green4",
         "blue4","cyan4","magenta4","yellow4" } */
    const int r[16] = { 0, 255, 255,   0,   0,   0, 255, 255, 105, 190, 139,   0,   0,   0, 139, 139 };
    const int g[16] = { 0, 255,   0, 255,   0, 255,   0, 255, 105, 190,   0, 139,   0, 139,   0, 139 };
    const int b[16] = { 0, 255,   0,   0, 255, 255, 255,   0, 105, 190,   0,   0, 139, 139, 139,   0 };
    if ( 0 <= n ) {
	n = n % 16;
	eggx_newrgbcolor(wn, r[n], g[n], b[n]);
    }
    return;
}

void newpencolor_( integer *wn, integer *n )
{
    eggx_newpen( *wn, *n ) ;
}

/* ꤹ(ߴroutine) */
void newpen_( integer *n )
{
    eggx_newpen( Wn, *n ) ;
}

/* õ */
void eggx_gclr( int wn )
{
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */

    XFillRectangle( Pc_dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].bggc, 
		   0, 0, Pc[wn].wszx, Pc[wn].wszy ) ;
    XDrawRectangle( Pc_dis, Pc[wn].pix[Pc[wn].wly], Pc[wn].bggc, 
		   0, 0, Pc[wn].wszx, Pc[wn].wszy ) ;
    if( Pc[wn].wly==Pc[wn].sly ){
	XClearWindow( Pc_dis, Pc[wn].win ) ;
	if( Pc[wn].attributes & DOCKAPP ){
	    XClearWindow( Pc_dis, Pc[wn].iconwin ) ;
	}
	do_auto_flush() ;
    }
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void gclr_( integer *wn )
{
    eggx_gclr( *wn ) ;
}

/* õ(ߴroutine) */
void clsx_( void )
{
    eggx_gclr( Wn ) ;
}

/* [3] */
void eggx_line( int wn, float xg, float yg, int mode )
{
    int xxg,yyg,f ;
    xyconv(wn,xg,yg,&xxg,&yyg) ;
    
    switch( mode ){
    case PENDOWN:
	wait_child() ;	/* imgsaveԤ */
	Ihflg=1 ;	/* ߶ػ */
	f=XX_DrawLine( Pc_dis, wn, Pc[wn].plx, Pc[wn].ply, xxg, yyg ) ;
	Pc[wn].plx=xxg ;
	Pc[wn].ply=yyg ;
	if(f) do_auto_flush() ;
	Ihflg=0 ;	/* ߶ػ߲ */
	chkexit() ;
	break ;
    case PENUP:
	Pc[wn].plx=xxg ;
	Pc[wn].ply=yyg ;
	break ;
    case PSET:
	Pc[wn].plx=xxg ;	/* 0.74 */
	Pc[wn].ply=yyg ;	/* 0.74 */
	wait_child() ;	/* imgsaveԤ */
	Ihflg=1 ;	/* ߶ػ */
	f=X_DrawPoint( Pc_dis, wn, xxg, yyg ) ;
	if(f) do_auto_flush() ;
	Ihflg=0 ;	/* ߶ػ߲ */
	chkexit() ;
	break ;
    }
}

void line_( integer *wn, real *xg, real *yg, integer *mode )
{
    eggx_line( *wn, *xg, *yg, *mode ) ;
}

void eggx_moveto( int wn, float xg, float yg )
{
    eggx_line(wn,xg,yg,PENUP);
}

void moveto_( integer *wn, real *xg, real *yg )
{
    eggx_line( *wn, *xg, *yg, PENUP ) ;
}

void eggx_lineto( int wn, float xg, float yg )
{
    eggx_line(wn,xg,yg,PENDOWN);
}

void lineto_( integer *wn, real *xg, real *yg )
{
    eggx_line( *wn, *xg, *yg, PENDOWN ) ;
}

void eggx_drawline( int wn, float xg0, float yg0, float xg1, float yg1 )
{
    int xx0,yy0,xx1,yy1,f=0 ;

    xyconv( wn,xg0,yg0,&xx0,&yy0 ) ;
    xyconv( wn,xg1,yg1,&xx1,&yy1 ) ;

    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    f |= XX_DrawLine( Pc_dis, wn, xx0, yy0, xx1, yy1 ) ;
    if ( f ) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;

    return;
}

void drawline_( integer *wn, real *xg0, real *yg0, real *xg1, real *yg1 )
{
    eggx_drawline( *wn, *xg0, *yg0, *xg1, *yg1 ) ;
}

void eggx_pset( int wn, float xg, float yg )
{
    int xxg,yyg,f ;
    xyconv(wn,xg,yg,&xxg,&yyg) ;
    
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    f=X_DrawPoint( Pc_dis, wn, xxg, yyg ) ;
    if(f) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void pset_( integer *wn, real *xg, real *yg )
{
    eggx_pset( *wn, *xg, *yg ) ;
}

/* (ߴroutine) */
void plot_( real *xg, real *yg, integer *mode )
{
    eggx_line( Wn, *xg, *yg, *mode ) ;
}

/*
typedef struct MyFont
{
  char *name;
  XFontStruct *font;
  XFontSet fontset;
  int height;
  int y;
} MyFont;
*/

/* եȥåȤ */
int eggx_gsetfontset( int wn, const char *argsformat, ... )
{
    XFontSetExtents *fset_extents;
    int rtv = 0;
    char *fontname_buf = NULL;
    const char *fontname = DEFAULTFONTSET;
    va_list ap;

    if ( argsformat != NULL ) {
	va_start(ap, argsformat);
	fontname_buf = _eggx_vasprintf(argsformat,ap);
	va_end(ap);
	fontname = fontname_buf;
    }
    
    Pc[wn].fontset = get_fontset(fontname);
    if ( Pc[wn].fontset == NULL ) {
	rtv = 1;
	if ( (Pc[wn].fontset = get_fontset(DEFAULTFONTSET)) == NULL ) {
	    if ( (Pc[wn].fontset = get_fontset(FALLBACKFONTSET)) == NULL ) {
		rtv = -1;
	    }
	}
    }
    /* XFontsOfFontSet(Pc[wn].fontset, &fs_list, &sl); */
    /* Pc[wn].font = fs_list[0]; */
    if ( rtv != -1 ) {
	fset_extents = XExtentsOfFontSet(Pc[wn].fontset);
	Pc[wn].fontheight = fset_extents->max_logical_extent.height;
    }
    /* Pc[wn].fonty = Scr.StdFont.font->ascent; */
    /* Pc[wn].entryheight = Pc[wn].fontheight + HEIGHT_EXTRA +2; */

    if ( fontname_buf != NULL ) free(fontname_buf);
    return (rtv);
}

void gsetfontset_( integer *wn, char *fset, integer *status )
{
    *status = (integer)eggx_gsetfontset( *wn, fset ) ;
}

/* ʸ[4] */
void drawstr_( integer *wn, real *xg, real *yg, real *size,
	       char *str, real *theta, integer *in_len )
{
    static int msg_flag0 = 0;
    int fsize ;
    int xxg,yyg ;
    unsigned short font_height ;
    int i,f=0,lf=0,dlen,line=0,len=0 ;
    char *ptr,*ptr1,*nptr,*last0_ptr ;
    char *buf=NULL ;

    xyconv(*wn,*xg,*yg,&xxg,&yyg) ;
    if( 1.0 <= *size && *size <= 24.0 ) fsize=(int)(*size) ;
    else{
	if( *size < 1.0 ) fsize=FONTSET ;
	else fsize=24 ;
    }

    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */

    if( Pc[*wn].fsz!=fsize ){
	if( FONTSET < fsize ){
	    if( Pc[*wn].fontstruct != NULL ){
		XFreeFont( Pc_dis, Pc[*wn].fontstruct ) ;
		Pc[*wn].fontstruct = NULL ;
	    }
	    Pc[*wn].fontstruct = XLoadQueryFont( Pc_dis, Pc_fnt[fsize-1] ) ;
	    if ( Pc[*wn].fontstruct == NULL ) {
		char *xf_buf = NULL;
		const char *ptr_x = strchr(Pc_fnt[fsize-1], 'x');
		if ( ptr_x != NULL ) {
		    xf_buf = _eggx_asprintf(Pc_fallbackfnt_fmt, ptr_x + 1);
		    Pc[*wn].fontstruct = XLoadQueryFont( Pc_dis, xf_buf );
		}
		else {
		    fprintf(stderr,"EGGX: [ERROR] Internal error!!\n");
		}
		if ( xf_buf != NULL ) free(xf_buf);
	    }
	    /* եȤĤʤ */
	    if ( Pc[*wn].fontstruct == NULL ) {
		if ( msg_flag0 < 1 ) {
		    fprintf(stderr,"EGGX: [WARNING] "
			    "Basic fonts for EGGX are not found. "
			    "Check your font setting of X server.\n");
		    msg_flag0++;
		}
		Pc[*wn].fontstruct = XLoadQueryFont( Pc_dis, Pc_fallbackfnt ) ;
		if ( Pc[*wn].fontstruct == NULL ) {
		    fprintf(stderr,"EGGX: [ERROR] "
			    "Default font 'fixed' is not found. "
			    "Check your font setting of X server.\n");
		    goto quit;
		}
	    }
	    XSetFont( Pc_dis, Pc[*wn].gc, Pc[*wn].fontstruct->fid ) ;
	}
	else{
	    if ( Pc[*wn].fontset == NULL ) {
		if ( eggx_gsetfontset(*wn,DEFAULTFONTSET) < 0 ) {
		    fprintf(stderr,
			    "EGGX: [WARNING] Cannot set default fontset.\n") ;
		}
	    }
#if 0	/* ver. 0.90: Ϥʤ餷 */
	    XFontStruct **fs_list;
	    char **sl;
	    XGCValues gv;
	    XFontsOfFontSet(Pc[*wn].fontset, &fs_list, &sl);
	    gv.font = fs_list[0]->fid;
	    XChangeGC( Pc_dis, Pc[*wn].gc, GCFont, &gv ) ;
#endif
	}
	Pc[*wn].fsz = fsize ;
    }

    if( FONTSET < fsize )
	font_height = Pc[*wn].fontstruct->ascent + Pc[*wn].fontstruct->descent ;
    else
	font_height = Pc[*wn].fontheight ;

    if( 0 <= (*in_len) ){
	len = (*in_len) ;
	buf=(char *)_eggx_xmalloc(sizeof(char)*(len+1)) ;
    }
    else{
	len = strlen(str) ;
	buf=(char *)_eggx_xmalloc(sizeof(char)*(len+1)) ;
    }

    for( i=0 ; i<len ; i++ ) buf[i]=str[i] ;
    /* strncpy(buf,str,len) ; */
    buf[len]='\0' ;
    nptr = buf ;
    last0_ptr = buf + len ;
    do {
	ptr = strchr(nptr,'\n') ;
	ptr1 = strchr(nptr,'\r') ;
	if( ptr != NULL || ptr1 != NULL ){
	    if( ptr != NULL && ptr1 != NULL ){
		if( ptr1-ptr < 0 ){
		    ptr=ptr1 ;
		    lf=1 ;
		}
		else lf=2 ;
	    }
	    else{
		if( ptr1 != NULL ){
		    ptr=ptr1 ;
		    lf=1 ;
		}
		else lf=2 ;
	    }
	    dlen = ptr - nptr ;
	}
	else{
	    dlen = last0_ptr - nptr ;
	    lf=0 ;
	}
	if( 0 < dlen ){
	    if( FONTSET < fsize ) {
		f=X_DrawString( Pc_dis, *wn, xxg, yyg + font_height*line, nptr, dlen ) ;
	    }
	    else {
		f=X_mbDrawString( Pc_dis, *wn, xxg, yyg + font_height*line, nptr, dlen ) ;
	    }
	}
	if( lf==2 ){
	    nptr = ptr + 1 ;
	    line++ ;
	}
	else if( lf==1 ){
	    nptr = ptr + 1 ;
	}
    } while( lf ) ;
    if(f) do_auto_flush() ;

 quit:
    if( buf != NULL ) free(buf) ;

    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

int eggx_drawstr( int wn, float x, float y, int size, float theta,
		  const char *argsformat, ... )
{
    va_list ap;
    char *str = NULL;
    integer w, l = -1;
    real sz,xx,yy,ttheta;

    if ( argsformat == NULL ) goto quit;

    va_start(ap, argsformat);
    str = _eggx_vasprintf(argsformat,ap);
    va_end(ap);

    w=(integer)wn ;
    xx=(real)x ;
    yy=(real)y ;
    sz=(real)size ;
    ttheta=(real)theta ;
    l=strlen(str) ;
    drawstr_(&w,&xx,&yy,&sz,str,&ttheta,&l) ;

 quit:
    if ( str != NULL ) free(str);
    return (l);
}

static int draw_a_symbol( int wn, float xg, float yg, int size, int sym )
{
    int x0,y0,x1,y1 ;
    int xx0=0,yy0=0,xx1=0,yy1=0 ;
    int hs,f=0 ;
    int xxg,yyg ;
    const float factors[10] = { 0.52,				/* 10 */
				0.125, 0.5, 0.55, 0.44, 0.42,	/* 1-5 */
				0.62, 0.68, 0.43, 0.42 };	/* 6-9 */

    if ( sym <= 0 ) return f;	/* 0 ʲϵѲ */
    else sym = sym % 10;	/* 10 ֤ 0 ֤ˤʤ */
    
    xyconv(wn,xg,yg,&xxg,&yyg) ;
#if 0	/* old: Version 0.85 ޤ (Pro-FORTRAN ˸ɤ碌) */
    switch( sym ){
    case 1:
	hs=(int)(size/8.0) ;
	break ;
    default:
	if( sym==2 || sym==8 || sym==9 || sym==0 ){
	    hs = (int)(size/4.0) ;
	}
	else hs = (int)(size/2.0)-1 ;
	if( hs<0 ) hs=0 ;
	break ;
    }
    y0 = yyg -hs ;
    if( sym==7 ) hs = (int)(size/4.0) ;
    x0 = xxg -hs ;
    x1 = xxg +hs ;
    y1 = yyg +hs ;
    if( sym==3 || sym==6 ){
	hs = (int)((float)hs*0.7) ;
	xx0 = xxg -hs ;
	yy0 = yyg -hs ;
	xx1 = xxg +hs ;
	yy1 = yyg +hs ;
    }
#endif
    /* Version 0.90 ǳƥܥ礭ΥХ󥹤 */
    hs = (int)(size * factors[sym]) ;
    if ( hs < 0 ) hs = 0 ;

    y0 = yyg - hs ;
    if ( sym == 7 ) hs = (int)(size/2.5) ;
    x0 = xxg - hs ;
    x1 = xxg + hs ;
    y1 = yyg + hs ;
    if ( sym == 3 || sym == 6 ) {
	hs = (int)((float)hs * 0.7) ;
	xx0 = xxg - hs ;
	yy0 = yyg - hs ;
	xx1 = xxg + hs ;
	yy1 = yyg + hs ;
    }

    switch ( sym ) {
    case 1:
	f=XX_DrawLine( Pc_dis, wn, xxg, y0, x1, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xxg, y0, x0, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xxg, y1, x1, yyg ) ;
	X_DrawLine( Pc_dis, wn, xxg, y1, x0, yyg ) ;
	break ;
    case 2:
	f=XX_DrawLine( Pc_dis, wn, xxg, y0, xxg, y1 ) ;
	XX_DrawLine( Pc_dis, wn, x0, yyg, x1, yyg ) ;
	break ;
    case 3:
	f=XX_DrawLine( Pc_dis, wn, xxg, y0, xxg, y1 ) ;
	XX_DrawLine( Pc_dis, wn, x0, yyg, x1, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xx0, yy0, xx1, yy1 ) ;
	XX_DrawLine( Pc_dis, wn, xx1, yy0, xx0, yy1 ) ;
	break ;
    case 4:
	f=X_DrawArc( Pc_dis, wn, x0, y0, x1-x0, y1-y0, 0, 64*360 ) ;
	break ;
    case 5:
	f=XX_DrawLine( Pc_dis, wn, x0, y0, x1, y1 ) ;
	XX_DrawLine( Pc_dis, wn, x1, y0, x0, y1 ) ;
	break ;
    case 6:
	f=XX_DrawLine( Pc_dis, wn, xx0, yy0, xxg, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xx1, yy0, xxg, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xxg, yyg, xxg, y1 ) ;
	break ;
    case 7:
	f=XX_DrawLine( Pc_dis, wn, xxg, y0, xxg, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xxg, y0, x0, y1 ) ;
	XX_DrawLine( Pc_dis, wn, xxg, y0, x1, y1 ) ;
	X_DrawLine( Pc_dis, wn, x0, y1, x1, y1 ) ;	
	break ;
    case 8:
	f=XX_DrawLine( Pc_dis, wn, xxg, yyg, xxg, y0 ) ;
	XX_DrawLine( Pc_dis, wn, x0, y0, x1, y0 ) ;
	XX_DrawLine( Pc_dis, wn, x1, y0, x1, y1 ) ;
	XX_DrawLine( Pc_dis, wn, x1, y1, x0, y1 ) ;
	X_DrawLine( Pc_dis, wn, x0, y1, x0, y0 ) ;
	break ;
    case 9:
	f=XX_DrawLine( Pc_dis, wn, x0, y0, x1, y1 ) ;
	XX_DrawLine( Pc_dis, wn, x1, y0, x0, y1 ) ;
	X_DrawLine( Pc_dis, wn, x0, y0, x1, y0 ) ;
	break ;
    case 0:
	f=XX_DrawLine( Pc_dis, wn, xxg, y0, xxg, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xxg, y0, x1, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xxg, y0, x0, yyg ) ;
	XX_DrawLine( Pc_dis, wn, xxg, y1, x1, yyg ) ;
	X_DrawLine( Pc_dis, wn, xxg, y1, x0, yyg ) ;
	break ;
    }
    return (f);
}

/* 󥿡ܥ[5] */
void eggx_drawsym( int wn, float xg, float yg, int size, int sym )
{
    int f;
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    f = draw_a_symbol(wn,xg,yg,size,sym);
    if (f) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

#if 0
void eggx_symbol( int wn, float xg, float yg, int size, int sym )
{
    eggx_drawsym(wn,xg,yg,size,sym);
}
#endif

void drawsym_( integer *wn, real *xg, real *yg, real *size, integer *sym )
{
    eggx_drawsym( *wn, *xg, *yg, *size, *sym ) ;
}

/* 󥿡ܥ(ߴroutine) */
void symbol_( real *xg, real *yg, real *size, 
	      void *k, real *theta, integer *len )
{
    integer *sym ;
    char *str ;
    if( *len < 0 ){
	sym = (integer *)k ;
	drawsym_( &(Wn),xg,yg,size,sym ) ;
    }
    else {
	str = (char *)k ;
	drawstr_( &(Wn),xg,yg,size,str,theta,len ) ;
    }
}

/* ʣΥܥ */
void eggx_drawsyms( int wn, const float x[], const float y[], int n,
		    int size, int sym )
{
    int xx,yy,i,f=0 ;
    XPoint *points=NULL ;
    if ( n < 1 ) return;
    points = (XPoint *)_eggx_xmalloc(sizeof(XPoint)*n) ;
    for( i=0 ; i<n ; i++ ){
	xyconv( wn,x[i],y[i],&xx,&yy ) ;
	points[i].x=xx ;
	points[i].y=yy ;
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    for ( i=0 ; i < n ; i++ ) {
	f |= draw_a_symbol( wn, points[i].x, points[i].y, size, sym ) ;
    }
    if ( f ) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    if ( points != NULL ) free(points) ;
    chkexit() ;
}

void drawsyms_( integer *wn, real x[], real y[], integer *n,
		real *size, integer *sym )
{
    int i ;
    float *xx ;
    float *yy ;
    if ( *n < 1 ) return;
    xx=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    yy=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    for( i=0 ; i < *n ; i++ ) xx[i] = (float)(x[i]) ;
    for( i=0 ; i < *n ; i++ ) yy[i] = (float)(y[i]) ;
    eggx_drawsyms( *wn, xx, yy, *n, *size, *sym ) ;
    free(yy) ;
    free(xx) ;
}

static int podr( integer n )
{
    int rt=1 ;
    if( n==0 ) return(0) ;
    while( (n/=10)!=0 ) rt++ ;
    return(rt) ;
}
/* ѿʸѴ */
/* : ѿ */
static char *rtoc( real *v, integer *n )
{
    static int mlc1 = 0;
    static char *adr = NULL;
    static char *fmt = NULL;
    int f;
    float vv;

    if ( -1 <= *n ) vv = *v;
    else vv = *v * pow(10, 1 + *n);
    if ( fmt == NULL ) {
	mlc1 = RTOC_UNITLEN;
	fmt = (char *)_eggx_xmalloc(sizeof(char)*mlc1);
    }
    while ( 1 ) {
	if ( 0 < *n ) {
	    if ( podr(*n)+4 <= mlc1 ) {
		sprintf(fmt,"%%.%df",(int)(*n));
		f = 0;
	    }
	    else f = -1;
	}
	else {
	    if ( *n == 0 ) sprintf(fmt,"%%.0f.");
	    else sprintf(fmt,"%%.0f");
      	    break;
	}
	if ( f != -1 ) break;
	mlc1 += RTOC_UNITLEN;
	fmt = (char *)_eggx_xrealloc(fmt,sizeof(char)*mlc1);
    }
    if ( adr != NULL ) {
	free(adr);
	adr = NULL;
    }
    adr = _eggx_asprintf(fmt,vv);
    return ( adr );
}

/* ѿʸѴ(ProFORTRAN) */
/* ѿ,,ʸ,Ǽ,ޤʸ */
void rtoc_( real *v, integer *n, integer *dn, char *dist, integer *m )
{
    char *adr ;
    if ( *dn < 1 ) return;
    adr=rtoc( v, n ) ;
    strncpy( dist, adr, *dn-1 ) ;
    dist[*dn-1]='\0' ;
    *m=*dn-1-strlen(adr) ;
    return;
}

/* ѿͤ[6] */
void drawnum_( integer *wn, real *xg, real *yg, real *size, 
	       real *v, real *theta, integer *n )
{
    char *adr ;
    integer len ;
    adr = rtoc( v, n ) ;
    len = strlen(adr) ;
    drawstr_( wn, xg, yg, size, adr, theta, &len ) ;
}

/* ѿͤ(ߴroutine) */
void number_( real *xg, real *yg, real *size, 
	      real *v, real *theta, integer *n )
{
    drawnum_( &(Wn), xg,yg,size,v,theta,n ) ;
}

static int dwtop( int wn, int si, int sj,
		  int xx[], int yy[], 
		  int x1[], int y1[],
		  int x2[], int y2[],
		  int x3[], int y3[] )
{
    int i=1 ;
    int f=0 ;
    XPoint points[3] ;
    do{
	switch(sj){
	case 1:
	    f |= XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x1[i],y1[i] ) ;
	    XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x2[i],y2[i] ) ;
	    X_DrawLine( Pc_dis, wn, x1[i],y1[i],x2[i],y2[i] ) ;
	    break ;
	case 2:
	    f |= XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x1[i],y1[i] ) ;
	    XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x2[i],y2[i] ) ;
	    X_DrawLine( Pc_dis, wn, x1[i],y1[i],x2[i],y2[i] ) ;
	    if( si==0 ) X_DrawLine( Pc_dis, wn, xx[i],yy[i],x3[i],y3[i] ) ;
	    break ;
	case 3:
	    f |= XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x1[i],y1[i] ) ;
	    XX_DrawLine( Pc_dis, wn, x1[i],y1[i],x3[i],y3[i] ) ;
	    if( si==0 ) X_DrawLine( Pc_dis, wn, xx[i],yy[i],x3[i],y3[i] ) ;
	    break ;
	case 4:
	    f |= XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x1[i],y1[i] ) ;
	    XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x2[i],y2[i] ) ;
	    if( si==0 ) XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x3[i],y3[i] ) ;
	    break ;
	case 5:
	    f |= XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x1[i],y1[i] ) ;
	    if( si==0 ) XX_DrawLine( Pc_dis, wn, xx[i],yy[i],x3[i],y3[i] ) ;
	    break ;
	case 6:
	    points[0].x=xx[i] ;
	    points[0].y=yy[i] ;
	    points[1].x=x1[i] ;
	    points[1].y=y1[i] ;
	    points[2].x=x2[i] ;
	    points[2].y=y2[i] ;
	    f |= X_FillPolygon( Pc_dis,wn,points,3,Convex,CoordModeOrigin) ;
	    break ;
	case 7:
	    points[0].x=xx[i] ;
	    points[0].y=yy[i] ;
	    points[1].x=x1[i] ;
	    points[1].y=y1[i] ;
	    points[2].x=x3[i] ;
	    points[2].y=y3[i] ;
	    f |= X_FillPolygon( Pc_dis,wn,points,3,Convex,CoordModeOrigin) ;
	    break ;
	}
    } while( --i > 1-si ) ;
    return(f) ;
}

/* [7] */
void eggx_drawarrow( int wn, float xs, float ys, float xt, float yt, 
		     float s, float w, int shape )
{
    int xx[2],yy[2] ;
    int si,sj ;		/* shape */
    float r ;
    float ss,ww ;
    float theta,phi ;
    float xl,yl ;
    int x1[2],x2[2],y1[2],y2[2],x3[2],y3[2] ;
    int rx1,rx2,ry1,ry2,rx3,ry3 ;
    int f=0 ;

    xyconv( wn,xs,ys,xx,yy ) ;
    xyconv( wn,xt,yt,xx+1,yy+1 ) ;
    xl = xx[0]-xx[1] ;
    yl = yy[0]-yy[1] ;
    if( shape<100 ){
	ss=s ;
	ww=w/2.0 ;
	si = shape/10 ;
    }
    else {
	ww = sqrt(xl*xl+yl*yl) ;
	ss = ww * s ;
	ww *= w ;
	ww /= 2.0 ;
	si = shape/10-10 ;
    }
	sj = shape % 10 ;
    r  = sqrt( ss*ss+ww*ww ) ;
    theta = atan2(yl,xl) ;
    phi = atan2(ww,ss) ;
    x1[1] = xx[1] + (rx1=r*cos(theta-phi)) ;
    y1[1] = yy[1] + (ry1=r*sin(theta-phi)) ;
    x2[1] = xx[1] + (rx2=r*cos(theta+phi)) ;
    y2[1] = yy[1] + (ry2=r*sin(theta+phi)) ;
    x3[1] = xx[1] + (rx3=r*cos(theta)) ;
    y3[1] = yy[1] + (ry3=r*sin(theta)) ;
    if( si==2 ){
	x1[0] = xx[0] - rx1 ;
	y1[0] = yy[0] - ry1 ;
	x2[0] = xx[0] - rx2 ;
	y2[0] = yy[0] - ry2 ;
	x3[0] = xx[0] - rx3 ;
	y3[0] = yy[0] - ry3 ;
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    f |= dwtop( wn, si, sj, xx,yy,x1,y1,x2,y2,x3,y3 ) ;
    switch( si ){
    case 1:
	if( 2<=sj ){
	    f |= X_DrawLine( Pc_dis, wn, xx[0],yy[0],xx[1],yy[1] ) ;
	}
	else f |= X_DrawLine( Pc_dis, wn, xx[0],yy[0],x3[1],y3[1] ) ;
	f |= X_DrawPoint( Pc_dis, wn, xx[0], yy[0] ) ;
	break ;
    case 2:
	if( 2<=sj ){
	    f |= X_DrawLine( Pc_dis, wn, xx[0],yy[0],xx[1],yy[1] ) ;
	}
	else f |= X_DrawLine( Pc_dis, wn, x3[0],y3[0],x3[1],y3[1] ) ;
	break ;
    }
    if(f) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void drawarrow_( integer *wn, real *xs, real *ys, real *xt, real *yt,
		 real *s, real *w, integer *shape )
{
    eggx_drawarrow( *wn, *xs, *ys, *xt, *yt, 
		    *s, *w, *shape ) ;
}

/* (ߴroutine) */
void arohd_( real *xs, real *ys, real *xt, real *yt,
	     real *s, real *w, integer *shape )
{
    eggx_drawarrow( Wn ,*xs,*ys,*xt,*yt,*s,*w,*shape ) ;
}

/* ߸̤ɤ٤ */
void eggx_fillarc( int wn, float xcen, float ycen, float xrad, float yrad,
		   float sang, float eang, int idir )
{
    int sa,da ;
    int x0,y0,x1,y1,xsize,ysize ;

    xyconv(wn,xcen-xrad,ycen-yrad,&x0,&y0) ;
    xyconv(wn,xcen+xrad,ycen+yrad,&x1,&y1) ;
    xsize=abs(x1-x0) ;
    ysize=abs(y1-y0) ;
    if( x1<x0 ) x0=x1 ;
    if( y1<y0 ) y0=y1 ;
    
    if( idir == -1 ){
	sa=sang*64.0 ;
	if( eang<sang ) da=-sa+ eang*64 ;
	else da=-sa-(360-eang)*64 ;
    }
    else{
	sa=sang*64.0 ;
	da=eang*64.0-sa ;
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    if( X_FillArc( Pc_dis, wn, x0, y0, xsize, ysize, sa, da ) )
	do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void fillarc_( integer *wn, real *xcen, real *ycen, real *xrad, real *yrad,
	       real *sang, real *eang, integer *idir )
{
    eggx_fillarc( *wn, *xcen, *ycen, *xrad, *yrad,
		  *sang, *eang, *idir ) ;
}

void eggx_fillcirc( int wn, float xcen, float ycen, float xrad, float yrad ) 
{
    eggx_fillarc( wn,xcen,ycen,xrad,yrad,0,360,1 ) ;
}

void fillcirc_( integer *wn, real *xcen, real *ycen, real *xrad, real *yrad )
{
    eggx_fillarc( *wn, *xcen, *ycen, *xrad, *yrad, 0,360,1 ) ;
}

/* ߸̤[8] */
void eggx_drawarc( int wn, float xcen, float ycen, float xrad, float yrad, 
		   float sang, float eang, int idir )
{
    int sa,da ;
    int x0,y0,x1,y1,xsize,ysize ;

    xyconv(wn,xcen-xrad,ycen-yrad,&x0,&y0) ;
    xyconv(wn,xcen+xrad,ycen+yrad,&x1,&y1) ;
    xsize=abs(x1-x0) ;
    ysize=abs(y1-y0) ;
    if( x1<x0 ) x0=x1 ;
    if( y1<y0 ) y0=y1 ;
    
    if( idir == -1 ){
	sa=sang*64.0 ;
	if( eang < sang ) da=-sa+ eang*64 ;
	else da=-sa-(360-eang)*64 ;
    }
    else{
	sa=sang*64.0 ;
	da=eang*64.0-sa ;
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    if( X_DrawArc( Pc_dis, wn, x0, y0, xsize, ysize, sa, da ) )
	do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void drawarc_( integer *wn, real *xcen, real *ycen, real *xrad, real *yrad,
	       real *sang, real *eang, integer *idir )
{
    eggx_drawarc( *wn, *xcen, *ycen, *xrad, *yrad, 
		  *sang, *eang, *idir ) ;
}

void eggx_drawcirc( int wn, float xcen, float ycen, float xrad, float yrad ) 
{
    eggx_drawarc( wn,xcen,ycen,xrad,yrad,0,360,1 ) ;
}

void eggx_circle( int wn, float xcen, float ycen, float xrad, float yrad ) 
{
    eggx_drawarc( wn,xcen,ycen,xrad,yrad,0,360,1 ) ;
}

void drawcirc_( integer *wn, real *xcen, real *ycen, real *xrad, real *yrad )
{
    eggx_drawarc( *wn, *xcen, *ycen, *xrad, *yrad, 0,360,1 ) ;
}

/* ߸̤(ߴroutine) */
void arc_( real *xcen, real *ycen, real *rad,
	   real *sang, real *eang, integer *idir )
{
    eggx_drawarc( Wn,*xcen,*ycen,*rad,*rad,*sang,*eang,*idir ) ;
}

/* ߸̤(ߴroutine) */
void circ1_( real *xcen, real *ycen, real *rad )
{
    eggx_drawarc( Wn,*xcen,*ycen,*rad,*rad,0,360,1) ;
}

/* Ĺ */
void eggx_drawrect( int wn, float x, float y, float w, float h )
{
    int x0,y0,x1,y1,xs,ys,width,height ;
    xyconv( wn,x,y,&x0,&y0 ) ;
    xyconv( wn,x+w,y+h,&x1,&y1 ) ;
    if( x0<x1 ) xs=x0 ;
    else xs=x1 ;
    if( y0<y1 ) ys=y0 ;
    else ys=y1 ;
    width=abs(x1-x0) ;
    height=abs(y1-y0) ;
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    if( X_DrawRectangle( Pc_dis,wn,xs,ys,width,height ) )
	do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void drawrect_( integer *wn, real *x, real *y, real *w, real *h )
{
    eggx_drawrect( *wn, *x, *y, *w, *h ) ;
}

/* Ĺɤ٤ */
void eggx_fillrect( int wn, float x, float y, float w, float h )
{
    int x0,y0,x1,y1,xs,ys,width,height,f ;
    xyconv( wn,x,y,&x0,&y0 ) ;
    xyconv( wn,x+w,y+h,&x1,&y1 ) ;
    if( x0<x1 ) xs=x0 ;
    else xs=x1 ;
    if( y0<y1 ) ys=y0 ;
    else ys=y1 ;
    width=abs(x1-x0) ;
    height=abs(y1-y0) ;
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    f=X_FillRectangle( Pc_dis,wn,xs,ys,width,height ) ;
    /* X_DrawRectangle( Pc_dis,*wn,xs,ys,width,height ) ; */
    if(f) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void fillrect_( integer *wn, real *x, real *y, real *w, real *h )
{
    eggx_fillrect( *wn, *x, *y, *w, *h ) ;
}

/* ʣ */
void eggx_drawpts( int wn, const float x[], const float y[], int n )
{
    int xx,yy,i,f=0 ;
    XPoint *points=NULL ;
    if ( n < 1 ) return;
    points = (XPoint *)_eggx_xmalloc(sizeof(XPoint)*n) ;
    for( i=0 ; i<n ; i++ ){
	xyconv( wn,x[i],y[i],&xx,&yy ) ;
	points[i].x=xx ;
	points[i].y=yy ;
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    for ( i=0 ; i < n ; i++ ) {
	f |= X_DrawPoint( Pc_dis, wn, points[i].x, points[i].y ) ;
    }
    if ( f ) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    if ( points != NULL ) free(points) ;
    chkexit() ;
}

void drawpts_( integer *wn, real x[], real y[], integer *n )
{
    int i ;
    float *xx ;
    float *yy ;
    if ( *n < 1 ) return;
    xx=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    yy=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    for( i=0 ; i < *n ; i++ ) xx[i] = (float)(x[i]) ;
    for( i=0 ; i < *n ; i++ ) yy[i] = (float)(y[i]) ;
    eggx_drawpts( *wn, xx, yy, *n ) ;
    free(yy) ;
    free(xx) ;
}

/*  */
void eggx_drawlines( int wn, const float x[], const float y[], int n )
{
    int xx,yy,i,f=0 ;
    XPoint *points=NULL ;
    if ( n < 1 ) return;
    points = (XPoint *)_eggx_xmalloc(sizeof(XPoint)*n) ;
    for( i=0 ; i<n ; i++ ){
	xyconv( wn,x[i],y[i],&xx,&yy ) ;
	points[i].x=xx ;
	points[i].y=yy ;
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    for ( i=0 ; i+1 < n ; i++ ) {
	f |= XX_DrawLine( Pc_dis, wn, points[i].x, points[i].y,
			  points[i+1].x, points[i+1].y ) ;
    }
    if ( f ) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    if ( points != NULL ) free(points) ;
    chkexit() ;
}

void drawlines_( integer *wn, real x[], real y[], integer *n )
{
    int i ;
    float *xx ;
    float *yy ;
    if ( *n < 1 ) return;
    xx=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    yy=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    for( i=0 ; i < *n ; i++ ) xx[i] = (float)(x[i]) ;
    for( i=0 ; i < *n ; i++ ) yy[i] = (float)(y[i]) ;
    eggx_drawlines( *wn, xx, yy, *n ) ;
    free(yy) ;
    free(xx) ;
}

/* ¿ѷ */
void eggx_drawpoly( int wn, const float x[], const float y[], int n )
{
    int xx,yy,i,f=0 ;
    XPoint *points=NULL ;
    if ( n < 1 ) return;
    points = (XPoint *)_eggx_xmalloc(sizeof(XPoint)*n) ;
    for( i=0 ; i<n ; i++ ){
	xyconv( wn,x[i],y[i],&xx,&yy ) ;
	points[i].x=xx ;
	points[i].y=yy ;
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    for ( i=0 ; i+1 < n ; i++ ) {
	f |= XX_DrawLine( Pc_dis, wn, points[i].x, points[i].y,
			  points[i+1].x, points[i+1].y ) ;
    }
    f |= XX_DrawLine( Pc_dis, wn, points[i].x, points[i].y,
		      points[0].x, points[0].y ) ;
    if ( f ) do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    if ( points != NULL ) free(points) ;
    chkexit() ;
}

void drawpoly_( integer *wn, real x[], real y[], integer *n )
{
    int i ;
    float *xx ;
    float *yy ;
    if ( *n < 1 ) return;
    xx=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    yy=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    for( i=0 ; i < *n ; i++ ) xx[i] = (float)(x[i]) ;
    for( i=0 ; i < *n ; i++ ) yy[i] = (float)(y[i]) ;
    eggx_drawpoly( *wn, xx, yy, *n ) ;
    free(yy) ;
    free(xx) ;
}

/* ¿ѷɤ٤ */
void eggx_fillpoly(int wn, const float x[], const float y[], int n, int shape)
{
    int sh=Complex ;
    int xx,yy,i ;
    XPoint *points=NULL ;
    if ( n < 1 ) return;
    points = (XPoint *)_eggx_xmalloc(sizeof(XPoint)*n) ;
    for( i=0 ; i<n ; i++ ){
	xyconv( wn,x[i],y[i],&xx,&yy ) ;
	points[i].x=xx ;
	points[i].y=yy ;
    }
    if( shape ) sh=Convex ;
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    if( X_FillPolygon( Pc_dis,wn,points,n,sh,CoordModeOrigin) )
	do_auto_flush() ;
    Ihflg=0 ;	/* ߶ػ߲ */
    if( points != NULL ) free(points) ;
    chkexit() ;
}

void fillpoly_( integer *wn, real x[], real y[], integer *n, integer *shape )
{
    int i ;
    float *xx ;
    float *yy ;
    if ( *n < 1 ) return;
    xx=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    yy=(float *)_eggx_xmalloc(sizeof(float)*(*n)) ;
    for( i=0 ; i < *n ; i++ ) xx[i] = (float)(x[i]) ;
    for( i=0 ; i < *n ; i++ ) yy[i] = (float)(y[i]) ;
    eggx_fillpoly( *wn, xx, yy, *n, *shape ) ;
    free(yy) ;
    free(xx) ;
}

void eggx_copylayer( int wn, int src, int dst )
{
    XGCValues gv ;
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */

    gv.tile = Pc[wn].pix[src] ;
    XChangeGC( Pc_dis, Pc[wn].pxgc, GCTile, &gv ) ;

    XFillRectangle( Pc_dis, Pc[wn].pix[dst], Pc[wn].pxgc, 
		    0,0, Pc[wn].wszx,Pc[wn].wszy ) ;
    if( dst == Pc[wn].sly ){
	XFillRectangle( Pc_dis, Pc[wn].win, Pc[wn].pxgc, 
			0,0, Pc[wn].wszx,Pc[wn].wszy ) ;
	if( Pc[wn].attributes & DOCKAPP ){
	    XFillRectangle( Pc_dis, Pc[wn].iconwin, Pc[wn].pxgc, 
			    0,0, Pc[wn].wszx,Pc[wn].wszy ) ;
	}
	do_auto_flush() ;
    }

    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
}

void copylayer_( integer *wn, integer *src, integer *dst )
{
    eggx_copylayer( *wn, *src, *dst ) ;
}

/* ɽ񤭹쥤򤹤롥sly:ɽ wly: */
void eggx_layer( int wn, int _sly, int _wly )
{
    int sl=0,wl=0 ;
    if( _sly!=0 ) sl=1 ;
    if( _wly!=0 ) wl=1 ;
    if( sl != Pc[wn].sly ){
	XGCValues gv ;
	wait_child() ;	/* imgsaveԤ */
	Ihflg=1 ;	/* ߶ػ */
	if( 0 < Pc[wn].cpid ){
	    if( sl ) kill(Pc[wn].cpid,SIGUSR2) ;
	    else kill(Pc[wn].cpid,SIGUSR1) ;
	}
	gv.tile = Pc[wn].pix[sl] ;
	XChangeGC( Pc_dis, Pc[wn].pxgc, GCTile, &gv ) ;
	XFillRectangle( Pc_dis, Pc[wn].win, Pc[wn].pxgc, 
			0,0, Pc[wn].wszx,Pc[wn].wszy ) ;
	if( Pc[wn].attributes & DOCKAPP ){
	    XFillRectangle( Pc_dis, Pc[wn].iconwin, Pc[wn].pxgc, 
			    0,0, Pc[wn].wszx,Pc[wn].wszy ) ;
	}
	do_auto_flush() ;
	Ihflg=0 ;	/* ߶ػ߲ */
	chkexit() ;
    }
    Pc[wn].sly = sl ;
    Pc[wn].wly = wl ;
}

void layer_( integer *wn, integer *sly, integer *wly )
{
    eggx_layer( *wn, *sly, *wly ) ;
}

/* for C... */
int eggx_putimg24( int wn, float x, float y,
		   int width, int height, unsigned char *buf )
{
    XImage image ;
    int xx,yy ;
    unsigned char *tbuf = NULL ;
    if( Pc_depth < 16 ) return(-1) ;
    xyconv( wn,x,y,&xx,&yy ) ;
    yy-=height-1 ;
    image.format           = ZPixmap ;
    image.width            = width ;
    image.height           = height ;
    image.xoffset          = 0 ;
    image.byte_order       = MSBFirst ;
    image.bitmap_bit_order = MSBFirst ;
    if( 16 < Pc_depth ){	/* 24bppξ */
	image.bits_per_pixel   = 32 ;
	image.bytes_per_line   = width*4 ;
	image.bitmap_unit      = 32 ;
	image.bitmap_pad       = 32 ;
	image.depth            = 24 ;
	if( Red_sft==16 && Green_sft==8 && Blue_sft==0 ){
	    image.data             = (char *)buf ;
	}
	else{
	    int i,j,k,fm=0 ;
	    if( Red_sft != 24 && Green_sft != 24 && Blue_sft != 24 ) fm = 0 ;
	    else if( Red_sft != 0 && Green_sft != 0 && Blue_sft != 0 ) fm = 3 ;
	    else if( Red_sft != 8 && Green_sft != 8 && Blue_sft != 8 ) fm = 2 ;
	    else if( Red_sft != 16 && Green_sft != 16 && Blue_sft != 16 ) fm = 1 ;
 
	    tbuf=(unsigned char *)_eggx_xmalloc(sizeof(unsigned char)*width*height*4) ;
	    image.data             = (char *)tbuf ;
	    for( j=0,i=0,k=0 ; i<width*height ; i++ ){
		k++ ;
		tbuf[j+3-Red_sft/8] = buf[k++] ;
		tbuf[j+3-Green_sft/8] = buf[k++] ;
		tbuf[j+3-Blue_sft/8] = buf[k++] ;
		tbuf[j+fm] = 0 ;
		j+=4 ;
	    }
	}
    }
    else{
	int i,j,k ;
	image.bits_per_pixel   = 16 ;
	image.bytes_per_line   = width*2 ;
	image.bitmap_unit      = 16 ;
	image.bitmap_pad       = 16 ;
	image.depth            = 16 ;

	tbuf=(unsigned char *)_eggx_xmalloc(sizeof(unsigned char)*width*height*2) ;
	image.data             = (char *)tbuf ;
	for( j=0,i=0,k=0 ; i<width*height ; i++ ){
	    unsigned short tmp_img = 0 ;
	    k++ ;
	    tmp_img |=
		(buf[k++] >> (8-Red_depth)) << Red_sft ;
	    tmp_img |=
		(buf[k++] >> (8-Green_depth)) << Green_sft ;
	    tmp_img |=
		(buf[k++] >> (8-Blue_depth)) << Blue_sft ;
	    tbuf[j++] = (unsigned char)(tmp_img >> 8) ;
	    tbuf[j++] = (unsigned char)(tmp_img & 0x0ff) ;
	}
    }
    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */
    XPutImage( Pc_dis,Pc[wn].pix[Pc[wn].wly],Pc[wn].gc,
	       &image,0,0,xx,yy,width,height) ;
    if( Pc[wn].wly==Pc[wn].sly ){
	XGCValues gv ;
	gv.tile = Pc[wn].pix[Pc[wn].wly] ;
	XChangeGC( Pc_dis, Pc[wn].pxgc, GCTile, &gv ) ;
	XFillRectangle( Pc_dis, Pc[wn].win, Pc[wn].pxgc, 
			0,0, Pc[wn].wszx,Pc[wn].wszy ) ;
	if( Pc[wn].attributes & DOCKAPP ){
	    XFillRectangle( Pc_dis, Pc[wn].iconwin, Pc[wn].pxgc, 
			    0,0, Pc[wn].wszx,Pc[wn].wszy ) ;
	}
	do_auto_flush() ;
    }
    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;
    if( tbuf != NULL ){
	free(tbuf) ;
	tbuf=NULL ;
    }
    return(0) ;
}

/* for FORTRAN */
void putimg24_( integer *wn, real *x, real *y,
		integer *width, integer *height, integer *buf )
{
    unsigned char *lbuf ;
    unsigned char *cadr ;
    integer *ladr ;
    int i,n ;

    n=(*width)*(*height) ;
    if ( n < 1 ) return;
    lbuf=(unsigned char *)_eggx_xmalloc(sizeof(unsigned char)*n*4) ;
    cadr=lbuf ;
    ladr=buf ;
    for( i=0 ; i<n ; i++ ){
	*cadr++=0 ;
	*cadr++=(unsigned char)(*ladr++) ;
	*cadr++=(unsigned char)(*ladr++) ;
	*cadr++=(unsigned char)(*ladr++) ;
    }
    if( eggx_putimg24( *wn,*x,*y,*width,*height,lbuf ) == -1 ){
	fprintf(stderr,"EGGX: [WARNING] Depth of X server is not enough.\n") ;
    }
    free(lbuf) ;
}

void eggx_gsetnonblock( int flag )
{
    int i;
    if ( flag == ENABLE ){
	Pc_nonblock = ENABLE ;
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		XSelectInput( Pc_dis, Pc[i].win, 
			  ButtonPressMask | KeyPressMask | PointerMotionMask );
	    }
	}
    }
    else {
	Pc_nonblock = DISABLE ;
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		XSelectInput( Pc_dis, Pc[i].win, 0 );
	    }
	}
    }
    return;
}

void gsetnonblock_( integer *flag )
{
    int i_flag = *flag;
    eggx_gsetnonblock(i_flag);
    return;
}

int eggx_ggetevent( int *type_r, int *code_r, float *x_r, float *y_r )
{
    int wn = -1;
    XEvent ev;
    KeySym key;
    char string[8] ;
    int type = -1, code = -1;
    float x = 0, y = 0;
    int i;

    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */

    if ( Pc_nonblock != ENABLE ) {
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		XSelectInput( Pc_dis, Pc[i].win, 
			  ButtonPressMask | KeyPressMask | PointerMotionMask );
	    }
	}
    }

    while ( 1 ) {
	if ( Pc_nonblock == ENABLE ) {
	    Bool tf = XCheckMaskEvent(Pc_dis,
			    ButtonPressMask | KeyPressMask | PointerMotionMask,
			    &ev);
	    if ( tf == False ) break;
	}
	else {
	    XNextEvent( Pc_dis, &ev );
	}
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		if ( ev.xany.window == Pc[i].win ) break;
	    }
	}
	if ( N_Pc <= i ) continue;
	else wn = i;
	if ( ev.type == MotionNotify ) {
	    code = 0 ;
	    x = (float)(ev.xbutton.x) / Pc[wn].wicx + Pc[wn].winxs ;
	    y = (float)(Pc[wn].wszy-1-ev.xbutton.y) / Pc[wn].wicy + Pc[wn].winys ;
	    type = MotionNotify ;
	    break ;
	}
	else if ( ev.type == ButtonPress ) {
	    code = ev.xbutton.button ;
	    x = (float)(ev.xbutton.x) / Pc[wn].wicx + Pc[wn].winxs ;
	    y = (float)(Pc[wn].wszy-1-ev.xbutton.y) / Pc[wn].wicy + Pc[wn].winys ;
	    type = ButtonPress ;
	    break ;
	}
	else if ( ev.type == KeyPress ) {
	    XLookupString((XKeyEvent *)&ev,string,sizeof(string),&key,NULL) ;
	    /* printf("[%X]",key) ;  fflush(stdout) ; */
	    switch( key ){
	    case XK_Right:		/* 륭 1c1f˳Ƥ */
		code = 0x01c ;
		break ;
	    case XK_KP_Right:
		code = 0x01c ;
		break ;
	    case XK_Left:
		code = 0x01d ;
		break ;
	    case XK_KP_Left:
		code = 0x01d ;
		break ;
	    case XK_Up:
		code = 0x01e ;
		break ;
	    case XK_KP_Up:
		code = 0x01e ;
		break ;
	    case XK_Down:
		code = 0x01f ;
		break ;
	    case XK_KP_Down:
		code = 0x01f ;
		break ;
	    case XK_Page_Up:		/* PageUp,PageDown  Ctrl+B,Ctrl+F ˳Ƥ */
		code = 0x002 ;
		break ;
	    case XK_KP_Page_Up:
		code = 0x002 ;
		break ;
	    case XK_Page_Down:
		code = 0x006 ;
		break ;
	    case XK_KP_Page_Down:
		code = 0x006 ;
		break ;
	    case XK_Home:		/* Home,End  Ctrl+A,Ctrl+E ˳Ƥ */
		code = 0x001 ;
		break ;
	    case XK_KP_Home:
		code = 0x001 ;
		break ;
	    case XK_End:
		code = 0x005 ;
		break ;
	    case XK_KP_End:
		code = 0x005 ;
		break ;
	    case XK_Pause:		/* Pause  Ctrl+C ˳Ƥ */
		code = 0x003 ;
		break ;
	    case XK_KP_Delete:
		code = 0x07f ;
		break ;
	    default:
		code = string[0] ;
		break ;
	    }
	    if( code != 0 ){
		type = KeyPress ;
		break ;
	    }
	}	/* else if... */
    }	/* while(1)... */

    if ( Pc_nonblock != ENABLE ) {
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		XSelectInput( Pc_dis, Pc[i].win, 0 );
	    }
	}
    }

    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;

    if ( 0 <= wn ) {
	if ( type_r != NULL ) *type_r = type;
	if ( code_r != NULL ) *code_r = code;
	if ( x_r != NULL ) *x_r = x;
	if ( y_r != NULL ) *y_r = y;
    }

    return( wn ) ;
}

void ggetevent_( integer *wn, integer *type, integer *code, real *x, real *y )
{
    float xx ;
    float yy ;
    int i_code ;
    int i_type ;
    *wn = (integer)eggx_ggetevent(&i_type,&i_code,&xx,&yy) ;
    *type = (integer)i_type ;
    *code = (integer)i_code ;
    *x = (real)xx ;
    *y = (real)yy ;
}

int eggx_ggetxpress( int *type_r, int *code_r, float *x_r, float *y_r )
{
    int wn = -1;
    XEvent ev;
    KeySym key;
    char string[8] ;
    int type = -1, code = -1;
    float x = 0, y = 0;
    int i;

    wait_child() ;	/* imgsaveԤ */
    Ihflg=1 ;	/* ߶ػ */

    if ( Pc_nonblock != ENABLE ) {
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		XSelectInput( Pc_dis, Pc[i].win, 
			      ButtonPressMask | KeyPressMask );
	    }
	}
    }

    while ( 1 ) {
	if ( Pc_nonblock == ENABLE ) {
	    Bool tf = XCheckMaskEvent(Pc_dis,
			    ButtonPressMask | KeyPressMask | PointerMotionMask,
			    &ev);
	    if ( tf == False ) break;
	}
	else {
	    XNextEvent( Pc_dis, &ev );
	}
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		if ( ev.xany.window == Pc[i].win ) break;
	    }
	}
	if ( N_Pc <= i ) continue;
	else wn = i;
	if ( ev.type == ButtonPress ) {
	    code = ev.xbutton.button ;
	    x = (float)(ev.xbutton.x) / Pc[wn].wicx + Pc[wn].winxs ;
	    y = (float)(Pc[wn].wszy-1-ev.xbutton.y) / Pc[wn].wicy + Pc[wn].winys ;
	    type = ButtonPress ;
	    break ;
	}
	else if ( ev.type == KeyPress ) {
	    XLookupString((XKeyEvent *)&ev,string,sizeof(string),&key,NULL) ;
	    /* printf("[%X]",key) ;  fflush(stdout) ; */
	    switch( key ){
	    case XK_Right:		/* 륭 1c1f˳Ƥ */
		code = 0x01c ;
		break ;
	    case XK_KP_Right:
		code = 0x01c ;
		break ;
	    case XK_Left:
		code = 0x01d ;
		break ;
	    case XK_KP_Left:
		code = 0x01d ;
		break ;
	    case XK_Up:
		code = 0x01e ;
		break ;
	    case XK_KP_Up:
		code = 0x01e ;
		break ;
	    case XK_Down:
		code = 0x01f ;
		break ;
	    case XK_KP_Down:
		code = 0x01f ;
		break ;
	    case XK_Page_Up:		/* PageUp,PageDown  Ctrl+B,Ctrl+F ˳Ƥ */
		code = 0x002 ;
		break ;
	    case XK_KP_Page_Up:
		code = 0x002 ;
		break ;
	    case XK_Page_Down:
		code = 0x006 ;
		break ;
	    case XK_KP_Page_Down:
		code = 0x006 ;
		break ;
	    case XK_Home:		/* Home,End  Ctrl+A,Ctrl+E ˳Ƥ */
		code = 0x001 ;
		break ;
	    case XK_KP_Home:
		code = 0x001 ;
		break ;
	    case XK_End:
		code = 0x005 ;
		break ;
	    case XK_KP_End:
		code = 0x005 ;
		break ;
	    case XK_Pause:		/* Pause  Ctrl+C ˳Ƥ */
		code = 0x003 ;
		break ;
	    case XK_KP_Delete:
		code = 0x07f ;
		break ;
	    default:
		code = string[0] ;
		break ;
	    }
	    if( code != 0 ){
		type = KeyPress ;
		break ;
	    }
	}	/* else if... */
    }	/* while(1)... */

    if ( Pc_nonblock != ENABLE ) {
	for ( i=0 ; i < N_Pc ; i++ ) {
	    if ( Pc[i].flg != 0 ) {
		XSelectInput( Pc_dis, Pc[i].win, 0 );
	    }
	}
    }

    Ihflg=0 ;	/* ߶ػ߲ */
    chkexit() ;

    if ( 0 <= wn ) {
	if ( type_r != NULL ) *type_r = type;
	if ( code_r != NULL ) *code_r = code;
	if ( x_r != NULL ) *x_r = x;
	if ( y_r != NULL ) *y_r = y;
    }

    return( wn ) ;
}

void ggetxpress_( integer *wn, integer *type, integer *code, real *x, real *y )
{
    float xx ;
    float yy ;
    int i_code ;
    int i_type ;
    *wn = (integer)eggx_ggetxpress(&i_type,&i_code,&xx,&yy) ;
    *type = (integer)i_type ;
    *code = (integer)i_code ;
    *x = (real)xx ;
    *y = (real)yy ;
}

int eggx_ggetch( void )
{
    int type, rt = -1 ;
    float x,y ;
    while ( 1 ) {
	int win = eggx_ggetxpress(&type,&rt,&x,&y);
	if ( Pc_nonblock == ENABLE ) {
	    if ( win < 0 ) {
		rt = -1;
		break;
	    }
	    if ( type == KeyPress ) break;
	}
	else {
	    if ( type == KeyPress ) break;
	}
    }
    return(rt) ;
}

void ggetch_( integer *rt )
{
    *rt = (integer)eggx_ggetch() ;
}

void inkeydollar_( integer *rt )
{
    *rt = (integer)eggx_ggetch() ;
}

/* Хå饦ɤǲsave(C) */
int eggx_saveimg( int wn, int ly, float xs, float ys, float xe, float ye, 
		  const char *filter, int depth, const char *argsformat, ... )
{
    char int_2[] = "2" ;
    char *fn=NULL,*tmp1=NULL ;
    char **args=NULL ;
    int sx0,sy0,sx1,sy1,width,height ;
    int i,j,nargs=0 ;
    int dpt, rtv = -1;
    char **args_c=NULL ;
    char ag1[16],ag2[16],ag3[16],ag4[16] ;
    char ag5[16],ag6[16],ag7[16],ag8[16] ;
    va_list ap ;

    if ( argsformat == NULL ) goto quit;
    
    wait_child() ;

    XFlush( Pc_dis ) ;
    XSync( Pc_dis,0 ) ;

    /* ե̾ */
    va_start(ap, argsformat);
    fn = _eggx_vasprintf(argsformat,ap);
    va_end(ap);

    /* ɸ */
    xyconv(wn,xs,ys,&sx0,&sy0) ;
    xyconv(wn,xe,ye,&sx1,&sy1) ;

    /* ɸå */
    if( Pc[wn].wszx <= sx0 ) sx0=Pc[wn].wszx-1 ;
    if( Pc[wn].wszx <= sx1 ) sx1=Pc[wn].wszx-1 ;
    if( Pc[wn].wszy <= sy0 ) sy0=Pc[wn].wszy-1 ;
    if( Pc[wn].wszy <= sy1 ) sy1=Pc[wn].wszy-1 ;
    if( sx0<0 ) sx0=0 ;
    if( sx1<0 ) sx1=0 ;
    if( sy0<0 ) sy0=0 ;
    if( sy1<0 ) sy1=0 ;
    width=abs(sx1-sx0)+1 ;
    height=abs(sy1-sy0)+1 ;
    if( sx1<sx0 ) sx0=sx1 ;
    if( sy1<sy0 ) sy0=sy1 ;

    if ( filter != NULL && *filter != '\0' ) {		/* СȤ */
	char *f_ptr;
	/* argsκ */
	tmp1 = _eggx_xstrdup(filter);
	f_ptr = tmp1;
	i = 0;
	while ( 1 ) {
	    int spn;
	    spn = strspn(f_ptr," ");
	    if ( 0 < spn ) {
		*f_ptr = '\0';
		f_ptr += spn;
	    }
	    spn = strcspn(f_ptr," ");
	    args = (char **)_eggx_xrealloc(args,sizeof(char *)*(i+1));
	    if ( 0 < spn ) {
		args[i++] = f_ptr;
		f_ptr += spn;
	    }
	    else {
		args[i] = NULL;
		break;
	    }
	}
	nargs = i;
    }
    dpt = 65536/depth ;
    
    args_c=(char **)_eggx_xmalloc(sizeof(char *)*(11+nargs+1)) ;
    sprintf(ag1,"%ld",(long)Pid) ;
    sprintf(ag2,"%ld",Pc[wn].pix[(ly)]) ;
    sprintf(ag3,"%d",sx0) ;
    sprintf(ag4,"%d",sy0) ;
    sprintf(ag5,"%d",width) ;
    sprintf(ag6,"%d",height) ;
    sprintf(ag7,"%d",dpt) ;
    sprintf(ag8,"%ld",(unsigned long)Pc_cmap) ;
    args_c[0]=Exec_slave_tmp ;
    args_c[1]=int_2 ;
    args_c[2]=ag1 ;
    args_c[3]=ag2 ;
    args_c[4]=ag3 ;
    args_c[5]=ag4 ;
    args_c[6]=ag5 ;
    args_c[7]=ag6 ;
    args_c[8]=ag7 ;
    args_c[9]=ag8 ;
    args_c[10]=fn ;
    for( j=0 ; j < nargs ; j++ ){
	args_c[11+j]=args[j] ;
    }
    args_c[11+j]=NULL ;
        
    while(1){
	if( mkexecfile() == -1 ){
	    fprintf(stderr,
		    "EGGX: [WARNING] Cannot create a file in /tmp/.\n") ;
	    rtv=-1 ;
	    goto quit ;
	}
	if( Exec_fd != -1 ){
	    close(Exec_fd);
	    Exec_fd=-1 ;
	}
	if( (Cpid_imgsave=fork())<0 ){
	    fprintf(stderr,"EGGX: [ERROR] fork() failed.\n") ;
	    rtv=-1 ;
	    goto quit ;
	}
	if( Cpid_imgsave==0 ){
	    /* ҥץ */
	    if( execv(*args_c,args_c)==-1){
		if( Pid == getppid() )
		    kill(Pid,SIGUSR2) ;
		/* fprintf(stderr,"file not found: %s\n",Exec_slave_tmp) ; */
		_exit(-1) ;
	    }
	}
	while( Bsyflg == 0 ){
	    eggx_msleep( 10 ) ;
	}
	if( Bsyflg==1 ){	/* ưǤʤϡBsyflg==-1 ˤʤ */
	    rmexecfile() ;
	    break ;
	}
	else{	/* Bsyflg==-1 */
	    i=0 ;
	    while( Cpid_imgsave != 0 ){
		/* fprintf(stderr,"waiting...Pid=%d cpid=%d \n",Pid,Cpid_imgsave) ; */
		if( i==10 ){
		    i=0 ;
		    /* fprintf(stderr,"check child = %d\n",kill(0,Cpid_tmp)) ; */
		    if( kill(0,Cpid_imgsave) ){
			/* Strange, but he died... */
			break ;
		    }
		}
		eggx_msleep( 10 ) ;
		i++ ;
	    }
	    Bsyflg=0 ;
	}
    }
    rtv = 0;
 quit:
    if( args_c!=NULL ) free(args_c) ;
    if( args!=NULL ) free(args) ;
    if( tmp1!=NULL ) free(tmp1) ;
    if( fn!=NULL ) free(fn) ;
    return (rtv);
}

/* FORTRAN saveimg */
void saveimg_( integer *wn, integer *ly, real *xs, real *ys, real *xe, real *ye,
	       char *fname, integer *cnt, char *filter, integer *depth )
{
    char *tmp=NULL,*tmp1,*tmp2 ;
    tmp = _eggx_xstrdup(fname) ;
    tmp1 = strrchr(tmp,'.') ;
    if( tmp1 != NULL ){
	*tmp1 = '\0' ;
	tmp1 = tmp ;
	tmp2 = strrchr(fname,'.') ;
    }
    else{
	tmp1 = tmp ;
	tmp2 = tmp+strlen(tmp) ;
    }
    if( -1 < *cnt ){
	eggx_saveimg( *wn, *ly, *xs, *ys, *xe, *ye,
		      filter, *depth, "%s%d%s",tmp1,(int)(*cnt),tmp2 ) ;
    }
    else{
	eggx_saveimg( *wn, *ly, *xs, *ys, *xe, *ye,
		      filter, *depth, "%s",fname ) ;
    }
    if( tmp != NULL ) free(tmp) ;
}

/* ========================== */
/* FORTRANؤä뤿δؿ */
void isnan_( real *value, integer *flag )
{
    int rtf ;
    rtf = isnan( *value ) ;
    rtf |= ISINF( *value ) ;
    *flag = (integer)rtf ;
}

void eggx_msleep( unsigned long msec )
{
#ifndef NO_USLEEP
    unsigned long t ;
    t=(unsigned long)(msec*1000) ;
    usleep( t ) ;
#else
    int rt ;
    struct timeval delay ;
    delay.tv_sec = (msec*1000) / 1000000L ;
    delay.tv_usec = (msec*1000) % 1000000L ;
    rt = select(0,
		(fd_set *) NULL,
		(fd_set *) NULL,
		(fd_set *) NULL,
		&delay) ;
    if( rt == -1 ){
        /* perror("select") ; */
        /* return(rt) ; */
	return ;
    }
    /* return(rt) ; */
    return ;
#endif	/* NO_USLEEP */
}

void msleep_( integer *time )
{
    eggx_msleep( (unsigned long)(*time) ) ;
}

#if 0
/* ========================== */
/* ߴ : ͽ */
void xwindow_( integer *wn, real *xs, real *ys, real *xe, real *ye )
{
    eggx_window( *wn, *xs, *ys, *xe, *ye ) ;
}

void xnewpen_( integer *wn, integer *n )
{
    eggx_newpen( *wn, *n ) ;
}

void xclsx_( integer *wn )
{
    eggx_gclr( *wn ) ;
}

void xplot_( integer *wn, real *xg, real *yg, integer *mode )
{
    eggx_line( *wn, *xg, *yg, *mode ) ;
}

void xarohd_( integer *wn, real *xs, real *ys, real *xt, real *yt,
	      real *s, real *w, integer *shape )
{
    eggx_drawarrow( *wn, *xs, *ys, *xt, *yt, 
		    *s, *w, *shape ) ;    
}

void xnumber_( integer *wn, real *xg, real *yg, real *size, 
	       real *v, real *theta, integer *n )
{
    char *adr ;
    integer len ;
    adr = rtoc( v, n ) ;
    len = strlen(adr) ;
    drawstr_( wn, xg, yg, size, adr, theta, &len ) ;
}

int eggx_depthinfo( void )
{
    int d,w,h,f ;
    f=eggx_ggetdisplayinfo(&d,&w,&h) ;
    if( f ) return(f) ;
    else return(d) ;
}

void depthinfo_( integer *rt )
{
    *rt = (integer)eggx_depthinfo() ;
}

void eggx_drawnum( int wn, float x, float y, int size, float v, float theta, int n )
{
    integer w,nn ;
    real xx,yy,sz,vv,ttheta ;
    w=(integer)wn ;
    xx=(real)x ;
    yy=(real)y ;
    sz=(real)size ;
    vv=(real)v ;
    ttheta=(real)theta ;
    nn=(integer)n ;
    drawnum_(&w,&xx,&yy,&sz,&vv,&ttheta,&nn) ;
}
#endif	/* #if 0 */
